/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"


/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ롣     ǰη
**************************************************************/
int  CurBRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurBRecBCt = 0;     /*** ȥ쥳ɿ             ***/
int  CurBParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
int  CurBChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/

int  CurTRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurTRecBCt = 0;     /*** ȥ쥳ɿ             ***/
int  CurTParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
int  CurTChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/


int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
void  PrnTreeCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnTreeCPCDOWN( FILE *fp,char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnEDRCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnEDRCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnTopDownCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnHokiCPCUP( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnHokiCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrintJWDinCPC( FILE *fp, char *cp, int curlev) ;
void  SetAccessDict( char *cp ) ;
void  SetPrintMode( char *cp ) ;
int   Access_by_date( CFile *log, char *date ) ;
int   ChkConceptNode( char dict, char *node) ;


void
main(int argc,  char **argv)
{
      int   ret1, ret2 ;
      int   lev, com;
      char  work[1024];
      char  *ary[64] ;
      FILE  *fp ;
      /*
         ưĶ
      */

      InitEnv() ;                /* ɽ⡼ɤʤɴĶ */
      DB_FileOpen() ;
      WORD_DB_Open() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      while( 1 ) {
          fprintf( stderr,">>> Input command\n" ) ;
          if ( gets( work ) == NULL )
            break ;
          fprintf(stderr,"IN>[%s]\n", work) ;
          if ( (com = InputCom(work,ary)) == 0 )
            continue ;
          lev = 1 ;
          /* Find & Print records */
          CurBRecBCt = 0 ;
          if ( ary[2] != NULL ) {
            if ( *ary[2] == '*' )
              lev = -1 ;
            else
              lev = atoi( ary[2] ) ;
          }
          if ( ary[3] != NULL ) {
            if ( (fp = fopen( ary[3], "w")) == NULL ) {
              fprintf(stderr,"[%s]ץǤޤ\n",ary[3]) ;
              continue ;
            }
          }
          else fp = stdout ;
          if ( (ENV_FLAGS & OUT_TOPDN ) != 0) {  /* ȥåץ */
            ret1 = AccessEDRCPC( com, ary[1], lev ) ;
            ret2 = PrintTOPDNCPC( fp, com, ary[1], lev ) ;
          }
          else if ( (ENV_FLAGS & OUT_TREE ) != 0 ) { /* ɽ⡼:ɽ⡼ɤ */
            ret2 = PrintTREECPC( fp, com, ary[1], lev ) ;
          }
          else if ( (ENV_FLAGS & OUT_HOOKI ) != 0 ) { /* ɽ⡼:ɽ⡼ɤ */
            ret2 = PrintHOKICPC( fp, com, ary[1], lev ) ;
          }
          else {  /* ţģҼ */
            ret2 = PrintEDRCPC( fp, com, ary[1], lev ) ;
          }
          if ( ary[3] != NULL ) 
            fclose( fp ) ;
      }

      WORD_DB_Close() ;
      DB_FileClose() ;

      return ;
}



/* δϢμ */
int AccessEDRCPC( int com, char *cid, int lev ) 
{
  int ret ;
  if ( com == 2 ) { /* ؤθ */
    return 0 ;
  }

  ret = GetSubClassrec( 'B', 0, cid, CurBParCID, CurBChiCID, CurBRecIDs, &CurBRecBCt, 8192 ) ;
  if ( ret < 0 ) {
    fprintf(stderr, "ERROR(AccessEDRCPC):ηϤΥѥǤʤ\n") ;
    return ;
  }
  ret = GetSubClassrec( 'T', 0, cid, CurTParCID, CurTChiCID, CurTRecIDs, &CurTRecBCt, 8192 ) ;
  if ( ret < 0 ) {
    fprintf(stderr, "ERROR(AccessEDRCPC):ηϤΥѥǤʤ\n") ;
    return ;
  }


  return 1 ;
}




/* طɽ */
int PrintTOPDNCPC( FILE *fp, int com, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  //for( ct = 0 ; ct < CurBRecBCt ; ct++)  {
  //  printf("Rec%07d\tP[ %x ] C[ %x ]\n",CurBRecIDs[ct], CurBParCID[ct], CurBChiCID[ct] ) ;
  //}
  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;

    PrnTopDownCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;

    PrnTreeCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}





/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnTopDownCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int ii ;
  int flag ;
  char cidstr[32] ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( curlev == 0 )
    fprintf( fp, " %02d:\t",curlev) ;
  else
    fprintf( fp, "-%02d:\t",curlev) ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp, "  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNode( fp, dict, *(leaf+cid) ); 
    fprintf( fp, "\n") ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNode(fp, dict, cidstr);
    fprintf( fp, "\n") ;
    if ( cid < 10 ) 
      return ;
  }
  for ( ii = flag = 0 ; ii < CurBRecBCt ; ii++ ) {
    if ( CurBChiCID[ii] == cid ) {
      PrnTopDownCPCUP( fp, dict, curlev+1, maxlev, CurBParCID[ii], leaf ) ;
      flag++ ;
    }
  }
  return ;
}




/* طɽ */
int PrintTREECPC( FILE *fp, int com, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  //for( ct = 0 ; ct < CurBRecBCt ; ct++)  {
  //  printf("Rec%07d\tP[ %x ] C[ %x ]\n",CurBRecIDs[ct], CurBParCID[ct], CurBChiCID[ct] ) ;
  //}
  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;

    PrnTreeCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /*ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;

    PrnTreeCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}



/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnTreeCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( curlev == 0 )
    fprintf( fp," %02d:\t",curlev) ;
  else
    fprintf( fp,"-%02d:\t",curlev) ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNode( fp, dict, *(leaf+cid) ); 
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNode( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }
  
  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;

    PrnTreeCPCUP( fp, dict, curlev+1, maxlev, HextoBin( cary[1] ), leaf ) ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}





/*
 Ϳ줿ǰɣĤޤᡢβ̳ǰéʤɽ롣
*/
void  PrnTreeCPCDOWN( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( curlev == 0 )
    fprintf( fp," %02d:\t",curlev) ;
  else
    fprintf( fp,"+%02d:\t",curlev) ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNodeEJ( fp, dict, *(leaf+cid) ); 
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNodeEJ( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;

    PrnTreeCPCDOWN( fp,  dict, curlev+1, maxlev, HextoBin( cary[2] ), leaf ) ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}




/*---*/




/* طɽ */
int PrintHOKICPC( FILE *fp, int com, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  //for( ct = 0 ; ct < CurBRecBCt ; ct++)  {
  //  printf("Rec%07d\tP[ %x ] C[ %x ]\n",CurBRecIDs[ct], CurBParCID[ct], CurBChiCID[ct] ) ;
  //}
  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;

    PrnHokiCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;

    PrnHokiCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}



/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnHokiCPCUP( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  kai, ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }
  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = kai = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) != 0 ) 
      kai++ ;
  }


  if ( curlev == 0 ) {
    fprintf( fp," %02d:(%5d)\t",curlev,kai) ;
  }
  else {
    fprintf( fp,"-%02d:(%5d)\t",curlev,kai) ;
  }
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNodeEJ( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNodeEJ( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }
  PrintJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;

    PrnHokiCPCUP( fp, dict, curlev+1, maxlev, HextoBin( cary[1] ), leaf ) ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}





/*
 Ϳ줿ǰɣĤޤᡢβ̳ǰéʤɽ롣
*/
void  PrnHokiCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, kai, len, slen, msz ;
  int  ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  if ( (ENV_FLAGS & OUT_J) == 0 || ( ENV_FLAGS & OUT_E ) == 0 ) {
    ret = ChkConceptNode( dict, cp) ;
    if ( ( (ENV_FLAGS & OUT_J) && ( ret & 0x01 ) == 0 ) ||
         ( (ENV_FLAGS & OUT_E) && ( ret & 0x02 ) == 0 ) )
    return ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = kai = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) != 0 ) 
      kai++ ;
  }

  if ( curlev == 0 ) {
    fprintf( fp," %02d:(%5d)\t",curlev,kai) ;
  }
  else {
    fprintf( fp,"+%02d:(%5d)\t",curlev,kai) ;
  }
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNodeEJ( fp, dict, *(leaf+cid) ); 
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNodeEJ( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  PrintJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */


  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;

    if ( strncmp( "0001", cary[2], 4) == 0 ) { 
      subleaf = cary[2] ;
      PrnHokiCPCDOWN( fp, dict, curlev+1, maxlev, 0, &subleaf ) ;
    }
    else {
      PrnHokiCPCDOWN( fp, dict, curlev+1, maxlev, HextoBin( cary[2] ), leaf ) ;
    }

  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}



void   PrintJWDinCPC( FILE *fp, char *cp, int curlev)  /* ܳǰ̻Ҥ˥󥯤ñ */
{
  int ret ;
  int ii, jj ;
  char data[8192], word[1024] ;
  int ret1, len, rids[1204] ;
  unsigned char *cary[64] ;

  if ( CID2WdRID == NULL )
    return  ;

  len = Get_IXT( CID2WdRID, cp, strlen(cp), data, 8192) ;
  for( ii = jj = 0 ; ii < len  ; ii += 4 ) 
    rids[jj++] = get4byte( &data[ii] ) ;
  if ( jj == 0 )
    return ;
  fprintf( fp,"           \t") ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  fprintf( fp,"      \t[" ) ;
  for( ii =0 ; ii < jj ; ii++ ) {
    len = Get_IXT( WdRID2Val, (char *)&rids[ii], 4, data, 8192) ;
    if ( len == 0 ) {
      fprintf(stderr,"ERROR(PrintJWDinCPC):쥳[%d]¸ߤʤ\n", rids[ii]) ;
      continue ;
    }
    ret = StartPts( data, len, cary) ;
    //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
    //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
    //*
    //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
    //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

    GetSyuushi( cary, word, 1024) ;
    fprintf( fp," %s",word) ;
  }
  fprintf( fp," ]\n") ;
  return  ;
}




/*---*/


/* ţģҷɽ */
int PrintEDRCPC( FILE *fp, int com, char *cid, int lev )
{
  int ct = 0 ;
  char **ccp = &cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp ," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;

    PrnEDRCPCUP( fp , 'B', 0 , lev, 0, ccp ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp ," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;

    PrnEDRCPCDOWN( fp , 'B', 0 , lev, 0, ccp ) ;
  }
  return 1 ;
}






/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnEDRCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, msz ;
  int  ret, slen, rid ;

  if ( maxlev > 0 ) {
    if ( curlev >= maxlev )
      return ;
  }

  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else if ( dict == 'T' && TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else
      continue ;
    PrnEDRCPCUP( fp, dict, curlev+1, maxlev, HextoBin( &work[4] ), leaf ) ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}





/*
 Ϳ줿ǰɣĤޤᡢβ̳ǰéʤɽ롣
*/
void  PrnEDRCPCDOWN( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, msz ;
  int  ret, slen, rid ;

  if ( maxlev > 0 ) {
    if ( curlev >= maxlev )
      return ;
  }
  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 ) 
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else if ( TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else 
      continue ;
    PrnEDRCPCDOWN( fp, dict, curlev+1, maxlev, HextoBin( cary[2] ), leaf ) ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}














/******************************************
// DB򥢥ꤵ줿֤˹줿Τ򤹤 
int Access_by_date( CFile *log, char *date )
{
  int  ret ,ret1;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[4096], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;
  //printf("ret=%d\n",ret) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  ret = split1( '-', date, ary) ;

  if ( ary[0] == '\0' ) { //  1997.1.1 
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], tob=[%x]\n",fromb,tob) ;
  ret = ret1 = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 4096) ;
    if ( len <= 0 )
      continue ;
    len = CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      ret1++ ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret1 >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}
******************************************/




/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return 0 ;
  }
  ary[0] = cp ;
  ary[1] = ary[2] = NULL ;

  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    if ( *cp == 'U' || *cp == 'u' )        /* ؤθ */
      ret = 1 ; 
    else if ( *cp == 'D' || *cp == 'd')    /* ؤθ */
      ret = 2 ; 
    else if ( *cp == ' ' || *cp == '\t' )  /* 岼ξؤθ */
      ret = 3 ;
    else {
      return -1 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;       /* Set pointer for Cid */
    cp = skip_a_word( ary[1] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[2] = ary[3] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[2] = skip_non_sp( cp ) ;  
    if ( ary[2] == NULL ) {            /* F  Cid */
      ary[3] = NULL ;
      return ret ;
    }
    if ( *ary[2] == '>' ) {            /* F Cid > outfile */
      cp = ary[2] + 1 ;
      ary[3] = skip_non_sp( cp ) ;
      cp = skip_a_word( ary[3] ) ;
      if ( cp != NULL && *cp != '\0') 
        *cp = '\0' ;
      ary[2] = NULL ;
      return ret ;
    }
    cp = skip_a_word( ary[2] ) ;
    if ( cp == NULL || *cp == '\0') {
      ary[3] = NULL ;
      return ret ;
    }
    *cp = '\0' ;
    cp++ ;
    ary[3] = skip_non_sp( cp ) ;
    if ( ary[3] == NULL ) {            /* Set Cid level */
      return ret ;
    }
    if ( *ary[3] == '>' ) {
      cp = ary[3] + 1 ;
      ary[3] = skip_non_sp( cp ) ;
    }
    cp = skip_a_word( ary[3] ) ;
    if ( cp != NULL) {
      *cp = '\0' ;
      cp++ ;
    }
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    if ( *cp == 'M' || *cp == 'm' ) {
      cp++ ;
      SetPrintMode(cp) ;   /* ץȥ⡼ɤ */
      return 0 ;
    }
  }
  ary[1] = cp ;
  return 3 ;
}






/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS **************************************\n") ;
  fprintf( stderr,"FU  ConceptID  [level] [> file] ؤθ\n") ;
  fprintf( stderr,"FD  ConceptID  [level] [> file] ؤθ\n") ;
  fprintf( stderr,"F   ConceptID  [level] [> file] 岼ؤθ\n") ;

  fprintf( stderr,"PM  {TREE}/EDR         ץȥ⡼ɤ\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr," levelϾάġͤϣ\n") ;
  fprintf( stderr,"\n") ;
}




int InitEnv()
{
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= ACCE_B | ACCE_T ;   /* ܸѸξ򥢥 */
  ENV_FLAGS |= OUT_TREE ;          /* ɽ⡼:ɽ⡼ɤ */
  //ENV_FLAGS |= OUT_HOOKI ;
  ENV_FLAGS |= OUT_J | OUT_E ;     /* ɽ⡼:ǰηϤɽоݤ */
  //ENV_FLAGS |= OUT_J ;   
  return 1 ;
}



/* ɽ⡼ɤ */
void SetPrintMode( char *cp )
{
  cp = skip_non_sp( cp ) ;

  if ( ( strncmp(cp,"TREE",4) == 0 ||
         strncmp(cp,"tree",4) == 0 ) && *(cp+4) <= ' ') {
    ENV_FLAGS &= ~(OUT_EDR | OUT_HOOKI ) ; 
    ENV_FLAGS |= OUT_TREE ;
    return ;
  }
  if ( ( strncmp(cp,"EDR",3) == 0 ||
         strncmp(cp,"edr",3) == 0 ) && *(cp+3) <= ' ') {
    ENV_FLAGS &= ~(OUT_TREE | OUT_HOOKI) ; 
    ENV_FLAGS |= OUT_EDR ;
    return ;
  }
  if ( ( strncmp(cp,"HOOKI",5) == 0 ||
         strncmp(cp,"hooki",5) == 0 ) && *(cp+5) <= ' ') {
    ENV_FLAGS &= ~(OUT_TREE | OUT_EDR) ; 
    ENV_FLAGS |= OUT_HOOKI ;
    return ;
  }
  if ( ( *cp == 'J' || *cp == 'j' ) && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_J | OUT_E ) ; 
    ENV_FLAGS |= OUT_J ;
    return ;
  }
  if ( ( *cp == 'E' || *cp == 'e' ) && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_J | OUT_E ) ; 
    ENV_FLAGS |= OUT_E ;
    return ;
  }
  if ( ( strncmp(cp,"JE",2) == 0 ||
         strncmp(cp,"je",2) == 0 ||
         strncmp(cp,"EJ",2) == 0 ||
         strncmp(cp,"ej",2) == 0 ) && *(cp+2) <= ' ') {
    ENV_FLAGS &= ( OUT_J | OUT_E ) ; 
    return ;
  }
  fprintf( stderr,"ERROR(SetPrintMode):Unknown[%s]\n",cp) ;
}



/* 뼭ꤹ */
void SetAccessDict( char *cp )
{
  if ( ( *cp == 'B' || *cp == 'b') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_T ; 
    ENV_FLAGS |= ACCE_B ;
    return ;
  }
  if ( ( *cp == 'T' || *cp == 't') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_B ; 
    ENV_FLAGS |= ACCE_T ;
    return ;
  }
  if ( ( strncmp(cp,"BT",3) == 0 ||
         strncmp(cp,"bt",3) == 0 ||
         strncmp(cp,"TB",3) == 0 ||
         strncmp(cp,"tb",3) == 0   ) && *(cp+3) <= ' ') {
    ENV_FLAGS |= ACCE_B | ACCE_T ;
    return ;
  }
  fprintf( stderr,"ERROR(SetAccessDict):Unknown[%s]\n",cp) ;
}









/************************************************************
  ǰΡɤƳǧ

  ʲξ""(̥륹ȥ)ݤå롣

  Ѹ쳵ǰФ                ͤ 0x08  ON
  ܸ쳵ǰФ              ͤ 0x04  ON
  Ѹ쳵ǰ                  ͤ 0x02  ON
  ܸ쳵ǰ                ͤ 0x01  ON

************************************************************/
int ChkConceptNode( char dict, char *node)
{
  int  len, ret  ;
  char work[128], work0[4096], *conc[32] ;

  if ( dict == 'B') {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len == 0 ) {
    return 0 ;
  }
  ret = 0 ;
  StartPtsCPH(work0, len, conc)  ;

  if ( strcmp(conc[3],"\"\"") != 0 ) 
    ret |= 0x04 ;   /* ܸ쳵ǰФ */
  if ( strcmp(conc[2],"\"\"") != 0 )
    ret |= 0x08 ;   /* Ѹ쳵ǰФ */
  if ( strcmp(conc[5],"\"\"") != 0 )
    ret |= 0x01 ;   /* ܸ쳵ǰ */
  if ( strcmp(conc[4],"\"\"") != 0 )
    ret |= 0x02 ;   /* Ѹ쳵ǰ   */
  return ret ;  
}





