/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"


/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ롣     ǰη
**************************************************************/
extern int  CurBRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
extern int  CurBRecBCt ;     /*** ȥ쥳ɿ             ***/
extern int  CurBParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
extern int  CurBChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/

extern int  CurTRecIDs[8192] ;  /*** ȥ쥳ֹǼꥢ ***/
extern int  CurTRecBCt ;     /*** ȥ쥳ɿ             ***/
extern int  CurTParCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/
extern int  CurTChiCID[8192] ;  /*** ̳ǰɣĳǼꥢ ***/


extern int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
//void  PrnTreeCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) ;
//void  PrnTreeCPCDOWN( FILE *fp,char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnEDRCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnEDRCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnTopDownCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) ;
void  PrnHokiCPCUP( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrnHokiCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf )  ;
void  PrintJWDinCPC( FILE *fp, char *cp, int curlev) ;
void  PrintTJWDinCPC( FILE *fp, char *cp, int curlev) ;
void  SetAccessDict( char *cp ) ;
void  SetPrintMode( char *cp ) ;
int   Access_by_date( CFile *log, char *date ) ;
int   ChkConceptNode( char dict, char *node) ;

int AccessEDRCPC( char dict, char *cid ) ;
int PrintTOPDNCPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintTREECPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintHOKICPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
int PrintEDRCPC( FILE *fp, int com, char dict, char *cid, int lev ) ;
char ExistCPC( char *node ) ;
int  SearchUp( char dict, char *cur, char *node ) ;
int  SearchDown( char dict, char *cur, char *node ) ;



/* δϢμ */
int AccessEDRCPC( char dict, char *cid ) 
{
  int ret ;

  if ( dict == 'B' ) {
    ret = GetSubClassrec( 'B', 0, cid, CurBParCID, CurBChiCID, CurBRecIDs, &CurBRecBCt, 8192 ) ;
    if ( ret < 0 ) {
      fprintf(stderr, "ERROR(AccessEDRCPC):ηϤΥѥǤʤ\n") ;
      return( -1 );
    }
    return 1 ;
  }
  ret = GetSubClassrec( 'T', 0, cid, CurTParCID, CurTChiCID, CurTRecIDs, &CurTRecBCt, 8192 ) ;
  if ( ret < 0 ) {
    fprintf(stderr, "ERROR(AccessEDRCPC):ηϤΥѥǤʤ\n") ;
    return( -1 ) ;
  }
  return 1 ;
}



/* δϢμɽ */
int PrAccessEDRCPC( char dict, char *node )
{
  int  ii , jj,top ;
  char *cid[2], *hdwd[2] ;
  char wk= '\0';

  cid[0] = node ;
  hdwd[0] = &wk ;
  if ( dict == 'B' ) {
    top = HextoBin( "3aa966" ) ; /* EDRγǰηϤΥȥåץΡ */
    PrnEdrCPCDATA( 'B', 0, top, cid, hdwd, CurBParCID, CurBChiCID, CurBRecBCt ) ;
  }
  if ( dict == 'T' ) {
    top = HextoBin( "2f3526" ) ; /* EDRγǰηϤΥȥåץΡ */
    PrnEdrCPCDATA( 'T', 0, top, cid, hdwd, CurTParCID, CurTChiCID, CurTRecBCt ) ;
  }

  return 1 ;
}  





/*
 Ϳ줿ǰɣĤΥѥ֤
*/ 
int   CrePathCPCDATA( int pcid, char **leaf, char **hdwd, int *workp, int *workc, int wct, char *buff, int *sz, int lim) 
{
  int ii, len ;
  int flag, ret ;
  char cidstr[32] ;

  if ( pcid <= 0 )  {
    pcid = (-1) * pcid ;
    len = strlen(*(leaf+pcid)) ;
    strcpy( (buff + *sz), *(leaf+pcid) ) ; 
    *sz += strlen( *(leaf+pcid) ) +1 ;
    return ;
  }
  sprintf(cidstr,"%06x",pcid) ;
  len = strlen( cidstr ) ;
  strcpy( (buff + *sz), cidstr ) ;
  *sz += strlen( cidstr ) ;
  *(buff + *sz ) = '/' ;
  (*sz)++ ;
  for ( ii = flag = 0 ; ii < wct ; ii++ ) {
    if ( *(workp+ii) == pcid ) {
      if ( flag != 0 ) {
        ret = CopyUpPath(buff,sz,lim) ; 
      }
      CrePathCPCDATA( *(workc+ii), leaf, hdwd, workp, workc, wct, buff, sz, lim ) ;
      flag++ ;
    }
    
  }
  if ( flag == 0 ) {
    CrePathCPCDATA(  0, leaf, hdwd, workp, workc, wct, buff, sz, lim ) ;
  }
}


int  CopyUpPath(char *buff,int *sz, int lim) 
{
  char *cp ;
  int  ii ;

  for( ii = *sz -1 ; ii > 0 ; ii-- ) {
    if ( *(buff + ii) == '\0' )
      break ;
  }
  if ( ii != 0 )
    ii++ ;
  for(  ; ii < *sz ; ii++ ) {
    *(buff + *sz) = *(buff + ii ) ;
    (*sz)++ ;
  }
}




/* δϢμɽ */
int GetPathEDRCPC( char dict, char *node, char *buff, int lim, int *sz )
{
  int  ii , jj,top ;
  char *cid[2], *hdwd[2] ;
  char wk= '\0';
  int  ret = 0 ;
  
  cid[0] = node ;
  hdwd[0] = &wk ;

  if ( dict == 'B' ) {
    top = HextoBin( "3aa966" ) ; /* EDRγǰηϤΥȥåץΡ */
    ret = CrePathCPCDATA( top, cid, hdwd, CurBParCID, CurBChiCID, CurBRecBCt, buff, sz, lim)  ;
  }
  if ( dict == 'T' ) {
    top = HextoBin( "2f3526" ) ; /* EDRγǰηϤΥȥåץΡ */
    ret = CrePathCPCDATA( top, cid, hdwd, CurTParCID, CurTChiCID, CurTRecBCt, buff, sz, lim)  ;
  }

  return ret ;
}  






/* طɽ */
int PrintTOPDNCPC( FILE *fp, int com, char dict, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;
    if ( dict == 'B' )
      PrnTopDownCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      PrnTopDownCPCUP( fp, 'T', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;
    if ( dict == 'B' )
      //PrnTreeCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
      PrnHokiCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      //PrnTreeCPCDOWN( fp, 'T', 0 , lev, 0, cpt ) ;
      PrnHokiCPCDOWN( fp, 'T', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}





/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnTopDownCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int ii ;
  int flag ;
  char cidstr[32] ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( curlev == 0 )
    fprintf( fp, " %02d:\t",curlev) ;
  else
    fprintf( fp, "-%02d:\t",curlev) ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp, "  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNode( fp, dict, *(leaf+cid) ); 
    fprintf( fp, "\n") ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNode(fp, dict, cidstr);
    fprintf( fp, "\n") ;
    if ( cid < 10 ) 
      return ;
  }
  for ( ii = flag = 0 ; ii < CurBRecBCt ; ii++ ) {
    if ( CurBChiCID[ii] == cid ) {
      PrnTopDownCPCUP( fp, dict, curlev+1, maxlev, CurBParCID[ii], leaf ) ;
      flag++ ;
    }
  }
  return ;
}




/* طɽ */
int PrintTREECPC( FILE *fp, int com, char dict, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  //for( ct = 0 ; ct < CurBRecBCt ; ct++)  {
  //  printf("Rec%07d\tP[ %x ] C[ %x ]\n",CurBRecIDs[ct], CurBParCID[ct], CurBChiCID[ct] ) ;
  //}
  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;
    if ( dict == 'B')
      //PrnTreeCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
      PrnHokiCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      //PrnTreeCPCUP( fp, 'T', 0 , lev, 0, cpt ) ;
      PrnHokiCPCUP( fp, 'T', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /*ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;
    if ( dict == 'B')
      //PrnTreeCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
      PrnHokiCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      //PrnTreeCPCDOWN( fp, 'T', 0 , lev, 0, cpt ) ;
      PrnHokiCPCDOWN( fp, 'T', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}








/* طɽ */
int PrintHOKICPC( FILE *fp, int com, char dict, char *cid, int lev ) 
{
  int ct = 0 ;
  char *cpt[2] ;

  //for( ct = 0 ; ct < CurBRecBCt ; ct++)  {
  //  printf("Rec%07d\tP[ %x ] C[ %x ]\n",CurBRecIDs[ct], CurBParCID[ct], CurBChiCID[ct] ) ;
  //}
  cpt[0] = cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;
    if ( dict == 'B' )
      PrnHokiCPCUP( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      PrnHokiCPCUP( fp, 'T', 0 , lev, 0, cpt ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;
    if ( dict == 'B' )
      PrnHokiCPCDOWN( fp, 'B', 0 , lev, 0, cpt ) ;
    else
      PrnHokiCPCDOWN( fp, 'T', 0 , lev, 0, cpt ) ;
  }
  return 1 ;
}



/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnHokiCPCUP( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, len, slen, msz ;
  int  kai, ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }
  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }
  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = kai = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) != 0 ) 
      kai++ ;
  }


  if ( curlev == 0 ) {
    fprintf( fp," %02d:(%5d)\t",curlev,kai) ;
  }
  else {
    fprintf( fp,"-%02d:(%5d)\t",curlev,kai) ;
  }
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNode( fp, dict, *(leaf+cid) ); 
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNode( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }
  if ( ( ENV_FLAGS & OUT_HOOKI ) != 0 ) {
    if ( dict == 'B' )
      PrintJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */
    else
      PrintTJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */
  }
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;


    if ( strncmp( "0001", cary[1], 4) == 0 ) { 
      subleaf = cary[1] ;
      PrnHokiCPCUP( fp, dict, curlev+1, maxlev, 0, &subleaf ) ;
    }
    else {
      PrnHokiCPCUP( fp, dict, curlev+1, maxlev, HextoBin( cary[1] ), leaf ) ;
    }
  }

  if ( len > 4096 )
    free( datap ) ;
  return ;
}





/*
 Ϳ줿ǰɣĤޤᡢβ̳ǰéʤɽ롣
*/
void  PrnHokiCPCDOWN(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, kai, len, slen, msz ;
  int  ret ;

  if ( maxlev > 0 ) {
    if ( curlev > maxlev )
      return ;
  }

  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  if ( (ENV_FLAGS & OUT_J) == 0 || ( ENV_FLAGS & OUT_E ) == 0 ) {
    ret = ChkConceptNode( dict, cp) ;
    if ( ( (ENV_FLAGS & OUT_J) && ( ret & 0x01 ) == 0 ) ||
         ( (ENV_FLAGS & OUT_E) && ( ret & 0x02 ) == 0 ) )
    return ;
  }
  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;

  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = kai = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) != 0 ) 
      kai++ ;
  }

  if ( curlev == 0 ) {
    fprintf( fp," %02d:(%5d)\t",curlev,kai) ;
  }
  else {
    fprintf( fp,"+%02d:(%5d)\t",curlev,kai) ;
  }
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  if ( cid <= 0 )  {
    cid = (-1) * cid ;
    PrnConceptNode( fp, dict, *(leaf+cid) ); 
    fprintf( fp,"\n") ;
    cp = *(leaf+cid) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    PrnConceptNode( fp, dict, cidstr);
    fprintf( fp,"\n") ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  if ( ( ENV_FLAGS & OUT_HOOKI ) != 0 ) {
    if ( dict == 'B' )
      PrintJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */
    else 
      PrintTJWDinCPC( fp, cp, curlev) ;  /* ܳǰ̻Ҥ˥󥯤ñ */
  }

  if ( maxlev > 0 ) {
    if ( ( curlev + 1 ) > maxlev ) {
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
  }
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return ;
    }
    fd = StartPtsCPC( work, slen, cary)  ;
    if ( strncmp( "0001", cary[2], 4) == 0 ) { 
      subleaf = cary[2] ;
      PrnHokiCPCDOWN( fp, dict, curlev+1, maxlev, 0, &subleaf ) ;
    }
    else {
      PrnHokiCPCDOWN( fp, dict, curlev+1, maxlev, HextoBin( cary[2] ), leaf ) ;
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}



void   PrintJWDinCPC( FILE *fp, char *cp, int curlev)  /* ܳǰ̻Ҥ˥󥯤ñ */
{
  int ret ;
  int ii, jj ;
  char data[8192], word[1024] ;
  int ret1, len, rids[1204] ;
  unsigned char *cary[64] ;

  if ( CID2WdRID == NULL )
    return  ;

  len = Get_IXT( CID2WdRID, cp, strlen(cp), data, 8192) ;
  for( ii = jj = 0 ; ii < len  ; ii += 4 ) 
    rids[jj++] = get4byte( &data[ii] ) ;
  if ( jj == 0 )
    return ;
  fprintf( fp,"           \t") ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  fprintf( fp,"      \t[" ) ;
  for( ii =0 ; ii < jj ; ii++ ) {
    len = Get_IXT( WdRID2Val, (char *)&rids[ii], 4, data, 8192) ;
    if ( len == 0 ) {
      fprintf(stderr,"ERROR(PrintJWDinCPC):쥳[%d]¸ߤʤ\n", rids[ii]) ;
      continue ;
    }
    ret = StartPts( data, len, cary) ;
    //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
    //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
    //*
    //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
    //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

    GetSyuushi( cary, word, 1024) ;
    fprintf( fp," %s",word) ;
  }
  fprintf( fp," ]\n") ;
  return  ;
}


void   PrintTJWDinCPC( FILE *fp, char *cp, int curlev)  /* ܳǰ̻Ҥ˥󥯤ñ */
{
  int ret ;
  int ii, jj ;
  char data[8192], word[1024] ;
  int ret1, len, rids[1204] ;
  unsigned char *cary[64] ;

  if ( TCID2WdRID == NULL )
    return  ;

  len = Get_IXT( TCID2WdRID, cp, strlen(cp), data, 8192) ;
  for( ii = jj = 0 ; ii < len  ; ii += 4 ) 
    rids[jj++] = get4byte( &data[ii] ) ;
  if ( jj == 0 )
    return ;
  fprintf( fp,"           \t") ;
  for ( ii = 0 ; ii < curlev ; ii++ ) {
    fprintf( fp,"  ") ;
  } 
  fprintf( fp,"      \t[" ) ;
  for( ii =0 ; ii < jj ; ii++ ) {
    len = Get_IXT( TWdRID2Val, (char *)&rids[ii], 4, data, 8192) ;
    if ( len == 0 ) {
      fprintf(stderr,"ERROR(PrintTJWDinCPC):쥳[%d]¸ߤʤ\n", rids[ii]) ;
      continue ;
    }
    ret = StartPts( data, len, cary) ;
    //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
    //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
    //*
    //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
    //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

    GetSyuushi( cary, word, 1024) ;
    fprintf( fp," %s",word) ;
  }
  fprintf( fp," ]\n") ;
  return  ;
}




/*---*/


/* ţģҷɽ */
int PrintEDRCPC( FILE *fp, int com, char dict, char *cid, int lev )
{
  int ct = 0 ;
  char **ccp = &cid ;

  if ( (com & 0x01) != 0 ) { /* ؤθ */
    fprintf( fp ," ********************** ǰ[ %s ] ξημɽ ************************\n", cid ) ;
    if ( dict == 'B' )
      PrnEDRCPCUP( fp , 'B', 0 , lev, 0, ccp ) ;
    else
      PrnEDRCPCUP( fp , 'T', 0 , lev, 0, ccp ) ;
  }

  if ( (com & 0x02) != 0 ) { /* ؤθ */
    fprintf( fp ," ********************** ǰ[ %s ] βημɽ ************************\n", cid ) ;
    if ( dict == 'B')
      PrnEDRCPCDOWN( fp , 'B', 0 , lev, 0, ccp ) ;
    else
      PrnEDRCPCDOWN( fp , 'T', 0 , lev, 0, ccp ) ;
  }
  return 1 ;
}






/*
 Ϳ줿ǰɣĤޤᡢξ̳ǰéʤɽ롣
*/
void  PrnEDRCPCUP(FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, len, msz ;
  int  ret, slen, rid ;

  if ( maxlev > 0 ) {
    if ( curlev >= maxlev )
      return ;
  }

  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 )
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else if ( dict == 'T' && TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else
      continue ;

    if ( strncmp( "0001", &work[4], 4) == 0 ) { 
      subleaf = &work[4] ;
      PrnEDRCPCUP( fp, dict, curlev+1, maxlev, 0, &subleaf ) ;
    }
    else {
      PrnEDRCPCUP( fp, dict, curlev+1, maxlev, HextoBin( &work[4] ), leaf ) ;
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}





/*
 Ϳ줿ǰɣĤޤᡢβ̳ǰéʤɽ롣
*/
void  PrnEDRCPCDOWN( FILE *fp, char dict, int curlev, int maxlev, int cid, char **leaf ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, len, msz ;
  int  ret, slen, rid ;

  if ( maxlev > 0 ) {
    if ( curlev >= maxlev )
      return ;
  }
  if ( cid <= 0 )  {
    ii = (-1) * cid ;
    cp = *(leaf+ii) ;
  }
  else {
    if ( cid < 10 ) 
      sprintf(cidstr,"%08x",cid) ;
    else
      sprintf(cidstr,"%06x",cid) ;
    if ( cid < 10 ) 
      return ;
    cp = cidstr ;
  }

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cp, strlen(cp) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cp, strlen( cp ) ) ;
  if ( len == 0 ) 
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cp, strlen(cp), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cp, strlen(cp), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else if ( TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      rid = get4byte( datap+ii ) ;
      fprintf( fp,"TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    }
    else 
      continue ;

    if ( strncmp( "0001", cary[2], 4) == 0 ) { 
      subleaf = cary[2] ;
      PrnEDRCPCDOWN( fp, dict, curlev+1, maxlev, 0, &subleaf ) ;
    }
    else {
      PrnEDRCPCDOWN( fp, dict, curlev+1, maxlev, HextoBin( cary[2] ), leaf ) ;
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return ;
}




/*
 Ϳ줿Ĥγǰ֤˿ƻҴطΩĤå롣
 ΩľϡΥ쥳ֹ֤
*/
int  ChkEDRCPC( char dict, char *parent, char *child ) 
{
  int flag ;
  char cidstr[32] , *cp ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  char *subleaf ;
  int  ii, fd, len, msz ;
  int  ret, slen, rid ;

  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, child, strlen(child) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, child, strlen( child ) ) ;
  if ( len == 0 ) 
    return ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return  ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, child, strlen(child), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, child, strlen(child), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      //printf( "CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
      if ( strcmp( parent, cary[1] ) == 0 ) {
        rid = get4byte( datap+ii ) ;
        if ( len > 4096 )
          free( datap ) ;
        return rid ;
      }
    }
    else if ( TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      //printf( "TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
      if ( strcmp( parent, cary[1] ) == 0 ) {
        rid = get4byte( datap+ii ) ;
        if ( len > 4096 )
          free( datap ) ;
        return rid ;
      }
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return( -1 );
}






/******************************************
// DB򥢥ꤵ줿֤˹줿Τ򤹤 
int Access_by_date( CFile *log, char *date )
{
  int  ret ,ret1;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[4096], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;
  //printf("ret=%d\n",ret) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  ret = split1( '-', date, ary) ;

  if ( ary[0] == '\0' ) { //  1997.1.1 
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], tob=[%x]\n",fromb,tob) ;
  ret = ret1 = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 4096) ;
    if ( len <= 0 )
      continue ;
    len = CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      ret1++ ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret1 >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}
******************************************/







/************************************************************
  ǰΡɤƳǧ

  ʲξ""(̥륹ȥ)ݤå롣

  Ѹ쳵ǰФ                ͤ 0x08  ON
  ܸ쳵ǰФ              ͤ 0x04  ON
  Ѹ쳵ǰ                  ͤ 0x02  ON
  ܸ쳵ǰ                ͤ 0x01  ON

************************************************************/
int ChkConceptNode( char dict, char *node)
{
  int  len, ret  ;
  char work[128], work0[4096], *conc[32] ;

  if ( dict == 'B') {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len == 0 ) {
    return 0 ;
  }
  ret = 0 ;
  StartPtsCPH(work0, len, conc)  ;

  if ( strcmp(conc[3],"\"\"") != 0 ) 
    ret |= 0x04 ;   /* ܸ쳵ǰФ */
  if ( strcmp(conc[2],"\"\"") != 0 )
    ret |= 0x08 ;   /* Ѹ쳵ǰФ */
  if ( strcmp(conc[5],"\"\"") != 0 )
    ret |= 0x01 ;   /* ܸ쳵ǰ */
  if ( strcmp(conc[4],"\"\"") != 0 )
    ret |= 0x02 ;   /* Ѹ쳵ǰ   */
  return ret ;  
}





/* ǰηϾ¸ߤ뤫ǧ */
char ChkNode( char *cid ) 
{
  char *nd[128] ;
  int   nct ;
  char *cp, dict ;

  nct = split1( '/', cid, nd) ;
  if ( strcmp( nd[nct-1], "." ) == 0 ) {
     cp = nd[nct-2] ;
  }
  else {
     cp = nd[nct-1] ;
  }

  dict = ExistCPC( cp ) ;

  return dict ;
}




int ChkLoopPath( char dict, char *cur, char *child )  /* 롼ץå */
{
  int  ret ;

//   cur ξ̤ childиʤOK
  ret = SearchUp( dict, cur, child ) ;
  if ( ret > 0 ) 
    return -1 ;

//   child β̤ cur иʤOK
  ret = SearchDown( dict, child, cur ) ;
  if ( ret > 0 )
    return -1 ;

  return 1 ;

}







/*  curΡɤξ̤ node ¸ߤУ̵С֤ */
int  SearchUp( char dict, char *cur, char *node ) 
{
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cur, strlen(cur) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cur, strlen(cur) ) ;
  if ( len == 0 )
    return 0 ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cur, strlen(cur), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cur, strlen(cur), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cur,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return( -1 );
    }
    fd = StartPtsCPC( work, slen, cary)  ;
    
    if ( strcmp( cary[1], node ) == 0 )
      return 1 ;
    ret = SearchUp( dict, cary[1], node ) ;
    if ( ret > 0 )
      return 1 ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ( -1 ) ;
}




/*  curΡɤβ̤ node ¸ߤУ̵С֤ */
int  SearchDown( char dict, char *cur, char *node ) 
{
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cur, strlen(cur) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cur, strlen(cur) ) ;
  if ( len == 0 )
    return 0 ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cur, strlen(cur), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cur, strlen(cur), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(SearchDown):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cur,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return( -1 );
    }
    fd = StartPtsCPC( work, slen, cary)  ;
    
    if ( strcmp( cary[2], node ) == 0 )
      return 1 ;
    ret = SearchDown( dict, cary[2], node ) ;
    if ( ret > 0 )
      return 1 ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ( -1 ) ;
}




/*  curΡɤľ node ¸ߤУ̵С֤ */
int  CheckDown( char dict, char *cur, char *node ) 
{
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cur, strlen(cur) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cur, strlen(cur) ) ;
  if ( len == 0 )
    return 0 ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cur, strlen(cur), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cur, strlen(cur), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x02) == 0 ) 
      continue ;
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(SearchDown):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cur,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return( -1 );
    }
    fd = StartPtsCPC( work, slen, cary)  ;
    if ( strcmp( cary[2], node ) == 0 ) {
      if ( len > 4096 )
        free( datap ) ;
      return 1 ;
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return ( -1 ) ;
}


/* ΡɤޤǤγǰΡɤˤѥ */
int GetPathStr( char *node , char *out, int size) 
{
  char dict, *cpt[2] ;
  int  ret, sz ;
  char buff[1024] ;
  
  *out = '\0' ;
  dict = ExistCPC( node ) ;
  if ( dict == '\0' )
    return 0;

  ret = AccessEDRCPC( dict, node ) ;
  sz = 0 ;
  ret = GetPathEDRCPC( dict, node, out, size, &sz) ;
  //printf("[%s] sz = %d  ret=%d\n", out, sz, ret) ;
  return sz ;
}




