/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"



int  Next_CNODE( char type )
{
  int  st, end ;
  int  ret ;
  char work[1024] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
    fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    return -1 ;
  }
  if ( type == 'B') {
    ret = Get_IXT( ControlDB, "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = Get_IXT( ControlDB, "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    end = get4byte( work ) ;
    if ( st > end ) {
      fprintf( stderr,"ERROR:ʳǰΡɤƤ뤳ȤǤޤǤ\n") ;
      return -1 ;
    }
    return st ;
  }
  else if ( type == 'T') {
    ret = Get_IXT( ControlDB, "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    }
    st = get4byte( work ) ;
    ret = Get_IXT( ControlDB, "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    }
    end = get4byte( work ) ;
    if ( st > end ) {
      fprintf( stderr,"ERROR:ʳǰΡɤƤ뤳ȤǤޤǤ\n") ;
      return -1 ;
    }
    return st ;
  }
  fprintf(stderr, "ERROR:ܸ졿Ѹλ꤬ޤ\n") ;
  return -1 ;
}






int  Create_CNODE( char type )
{
  int  st, end ;
  int  ret ;
  char work[1024] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
    fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    return -1 ;
  }
  if ( type == 'B') {
    ret = Get_IXT( ControlDB, "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = Get_IXT( ControlDB, "CP_B_T_ID", strlen( "CP_B_T_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    end = get4byte( work ) ;
    if ( st > end ) {
      fprintf( stderr,"ERROR:ʳǰΡɤƤ뤳ȤǤޤǤ\n") ;
      return -1 ;
    }
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "CP_B_F_ID", strlen( "CP_B_F_ID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  else if ( type == 'T') {
    ret = Get_IXT( ControlDB, "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    }
    st = get4byte( work ) ;
    ret = Get_IXT( ControlDB, "CP_T_T_ID", strlen( "CP_T_T_ID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    }
    end = get4byte( work ) ;
    if ( st > end ) {
      fprintf( stderr,"ERROR:ʳǰΡɤƤ뤳ȤǤޤǤ\n") ;
      return -1 ;
    }
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "CP_T_F_ID", strlen( "CP_T_F_ID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  fprintf(stderr, "ERROR:ܸ졿Ѹλ꤬ޤ\n") ;
  return -1 ;
}





int  Create_CPHRID( char type )
{
  int  st, end ;
  int  ret ;
  char work[1024] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
    fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    return -1 ;
  }
  if ( type == 'B') {
    ret = Get_IXT( ControlDB, "CPH_RID", strlen( "CPH_RID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "CPH_RID", strlen( "CPH_RID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  else if ( type == 'T') {
    ret = Get_IXT( ControlDB, "TCPH_RID", strlen( "TCPH_RID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "TCPH_RID", strlen( "TCPH_RID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;

  }
  fprintf(stderr, "ERROR:ܸ졿Ѹλ꤬ޤ\n") ;
  return -1 ;
}



int  Create_CPCRID( char type )
{
  int  st, end ;
  int  ret ;
  char work[1024] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
    fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    return -1 ;
  }
  if ( type == 'B') {
    ret = Get_IXT( ControlDB, "CPC_RID", strlen( "CPC_RID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "CPC_RID", strlen( "CPC_RID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  else if ( type == 'T') {
    ret = Get_IXT( ControlDB, "TCPC_RID", strlen( "TCPC_RID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "TCPC_RID", strlen( "TCPC_RID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  fprintf(stderr, "ERROR:ܸ졿Ѹλ꤬ޤ\n") ;
  return -1 ;
}




int  Create_CPTRID( char type )
{
  int  st, end ;
  int  ret ;
  char work[1024] ;

  if ( ControlDB == NULL ) {
    fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
    fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
    return -1 ;
  }
  if ( type == 'B') {
    ret = Get_IXT( ControlDB, "CPT_RID", strlen( "CPT_RID" ) , work, 128 ) ;
    if ( ret <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    st = get4byte( work ) ;
    ret = st ;
    st++ ;
    put4byte( st, work ) ;
    st = Put_IXT( ControlDB, "CPT_RID", strlen( "CPT_RID" ) , work, 4 ) ;
    if ( st <= 0 ) {
      fprintf(stderr, "ERROR:ȥDBץǤޤ\n") ;
      fprintf(stderr, "      Ķѿ CONT_DB ǧƤ\n") ;
      return -1 ;
    }
    return ret ;
  }
  fprintf(stderr, "ERROR:ܸ졿Ѹλ꤬ޤ\n") ;
  return -1 ;
}


