/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"



/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ
**************************************************************/
int  CurRecIDs[32768] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurRecCt = 0;       /*** ȥ쥳ɿ             ***/
int  BakRecIDs[32768] ;  /*** Υȥ쥳ֹǼꥢ ***/
int  BakRecCt = 0;       /*** Υȥ쥳ɿ             ***/

int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
void SetPrintMode( char *cp ) ;
void print_CurRecord( char *recid, char *file ) ;
void print_CurRecords( char *ct, char *file ) ;
void print_CurRecordt( char *textid, char *file ) ;
int  Access_by_date( CFile *log, char *date ) ;


int
main(int argc,  char **argv)
{
      int   vflag = 2 ,ret1, ret2 ;
      int   ii, jj , com;
      int   rid ;
      char  work[1024], work1[1024], work2[1024] ;
      CFile *cpt1, *fpt1 , *ypt1, *hpt1 ;
      CFile *cpt2, *fpt2 , *ypt2, *hpt2 ;
      CFile *lpt1, *lpt2  ;
      char  *wdenv ;
      char  file[512] ;
      MorphInfo  morph[4096] ;
      char  *ary[64] ;

      /*
         ưĶ
      */

      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */
      
      rid = JCorpus_DB_Open() ;
      if ( rid < 0 ) {
        return 0 ;
      }

      while( 1 ) {
          fprintf( stderr,">>> Input command  (Current Record = %d)\n",CurRecCt) ;
          if ( gets( work ) == NULL )
            break ;
          if ( (com = InputCom(work,ary)) == 0 )
            continue ;

          if ( ( com > 10 && com < 20 ) && CurRecCt <= 0 )  /* ǥȤʤ */
              continue ;
          if ( com == 20 ) {  /* 쥳ɣɣĤˤ븡ɽ */
            print_CurRecord( ary[1], ary[2]) ;
            continue ;
          }
          else if ( com == 21 ) { /* ̤ɽ */
            print_CurRecords( ary[1], ary[2] ) ;
            continue ;
          }
          else if ( com == 25 ) { /* ƥֹˤ븡ɽ */
            print_CurRecordt( ary[1], ary[2] ) ;
            continue ;
          }

          switch( com ) {   /* Find & Select records */
            case   1 :  /* ɽ [& ʻ]ˤ븡 */
            case  11 :  /* ɽ [& ʻ]ˤ룲 */
                ret1 = Conv2Big(work1, ary[1]) ;
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRHIDX( HDWD2JCORPRecID, work1, ary[2] ) ;
                if ( com == 11 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   3 :  /* ǰIDˤ븡 */
            case  13 :  /* ǰIDˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDX( CHID2JCORPRecID, ary[1] ) ;
                if ( com == 13 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   9 :   /* ˤ븡 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = Access_by_date( lpt1, ary[1] ) ;
                if ( com == 19 )
                  ret2 = IntersectEDRIDX() ;
                break ;   
          }
      }


      JCorpus_DB_Close() ;
      return 0 ;
}



int BackUpCurentRec()
{
  int ii ;

  for( ii = 0 ; ii < CurRecCt ; ii++ ) 
    BakRecIDs[ii] = CurRecIDs[ii] ; 
  BakRecCt = CurRecCt ;
  return BakRecCt ;
}


int RecoverCurentRec()
{
  int ii ;
  for( ii = 0 ; ii < BakRecCt ; ii++ )
    CurRecIDs[ii] = BakRecIDs[ii] ;
  CurRecCt = BakRecCt ;
  return BakRecCt ;
}


int UniqueCurentRec()
{
  int ii, jj, kk ;

  kk = 0 ;
  for( ii = 0 ; ii < BakRecCt ; ii++ ) {
    for( jj = 0 ; jj < kk ; jj++ ) {
      if ( CurRecIDs[jj] == CurRecIDs[ii] )
        break ;
    }
    if ( jj == kk )
      CurRecIDs[kk++] = CurRecIDs[ii] ;
  }
  CurRecCt = kk ;
  return kk ;
}


int AccessEDRHIDX( CFile *hpt, char *key, char *cat ) 
{
  int   ret, cor_cat ;
  int   ii,jj ;
  char  rids[500000] ;

  if ( hpt == NULL )
    return 0 ;
  ret = Get_IXT (hpt, key, strlen(key), rids, 500000) ;
  if ( ret == 0 )
    return ret ;

  if ( cat == NULL || *cat == '\0' )  {
    for( ii = CurRecCt, jj = 0 ; jj < ret ; ii++, jj += 5 ) {
      CurRecIDs[ii] = get4byte( &rids[jj+1] ) ;
    }
  }
  else {
    cor_cat = GetJCorpPoSID( cat ) ;
    for( ii = CurRecCt, jj = 0 ; jj < ret ; jj += 5 ) {
      if ( cor_cat != rids[jj] )
        continue ;
      CurRecIDs[ii++] = get4byte( &rids[jj+1] ) ;
    }
  }
  CurRecCt = ii ;
  return ret ;
}


int AccessEDRIDX( CFile *hpt, char *key ) 
{
  int   ret ;
  int   ii,jj ;
  char  rids[400000] ;

  if ( hpt == NULL )
    return 0 ;
  ret = Get_IXT (hpt, key, strlen(key), rids, 400000) ;
  if ( ret == 0 )
    return ret ;
  for( ii = CurRecCt, jj = 0 ; jj < ret ; ii++, jj += 4 ) {
    CurRecIDs[ii] = get4byte( &rids[jj] ) ;
  }
  CurRecCt = ii ;
  return ret ;
}


int IntersectEDRIDX()
{
  int ii, jj, kk ;

  kk = 0 ;
  for( ii = 0 ; ii < CurRecCt ; ii++ ) {
    for ( jj = 0 ; jj < BakRecCt ; jj++ ) {
      if ( CurRecIDs[ii] == BakRecIDs[jj] ) {
        CurRecIDs[kk++] = CurRecIDs[ii] ;
        break ;
      }
    }
  }
  CurRecCt = kk ;
}





int Access_by_date( CFile *log, char *date )
{
/* DB򥢥ꤵ줿֤˹줿Τ򤹤 */
  int  ret ;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[32768], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;

  ret = split1( '-', date, ary) ;

  if ( *ary[0] == '\0' ) { /*  1997.1.1 */
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else if ( *ary[1] == '\0' ) { /*  1997.1.1 */
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], to[%x]\n",fromb,tob) ;
  ret = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 32768) ;
    if ( len <= 0 )
      continue ;
    CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JCO%07d\n", Rid ) ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}








/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return 0 ;
  }
  ary[0] = cp ;
  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룱 */
      case  'h' :  ret = 1 ; break ;
      case  'R' :          /* reading    ɤߤˤ룱 */
      case  'r' :  ret = 2 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룱 */
      case  'c' :  ret = 3 ; break ;
      case  'D' :          /* from-to    ˤ룱 */
      case  'd' :  ret = 9 ; break ;
      defaule   :  return 0 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    cp = skip_a_word(ary[1]) ;
    if ( cp != NULL && *cp != '\0' ) {
      *cp = '\0' ;
      cp++ ;
    }
    ary[2] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'S' || *cp == 's' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룲 */
      case  'h' :  ret = 11 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룲 */
      case  'c' :  ret = 13 ; break ;
      default   :  return 0 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    cp = skip_a_word(ary[1]) ;
    if ( cp != NULL && *cp != '\0' ) {
      *cp = '\0' ;
      cp++ ;
    }
    ary[2] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    if ( *cp == '\0' || *cp <= ' ') {
      ary[1] =  NULL ;
      cp = skip_non_sp( cp ) ;
      if ( cp == NULL || *cp == '\0' ) {
        ary[2] = NULL ;
        return 21 ;
      }
      if ( *cp == '>' ) 
        cp++ ;
      ary[2] = skip_non_sp( cp ) ;
      cp = skip_a_word(ary[2]) ;
      if ( cp != NULL && *cp != '\0' ) 
        *cp = '\0' ;
      return 21 ;          /* ȥ쥳ɤξɽؼ */
    }
    if ( *cp >= '0' && *cp <= '9' )  {
      ary[1] = cp ;
      cp = skip_a_word(ary[1]) ;
      if ( cp == NULL || *cp == '\0' ) {
        ary[2] = NULL ;
        return 21 ;
      }
      *cp = '\0' ;
      cp++ ;
      if ( *cp == '>' ) 
        cp++ ;
      ary[2] = skip_non_sp( cp ) ;
      cp = skip_a_word(ary[2]) ;
      if ( cp != NULL && *cp != '\0' ) 
        *cp = '\0' ;
      return 21 ;          /* ȥ쥳ɤξɽؼ */
    }
    if ( *cp == 'M' || *cp == 'm' ) {
      cp++ ;
      SetPrintMode(cp) ;   /* ץȥ⡼ɤ */
      return 0 ;
    }
  }
  if (*cp == 'I' || *cp == 'i' ) {
    ary[1] = skip_non_sp( cp + 1 ) ;
    if ( ary[1] == NULL ) {
      fprintf(stderr,"ERROR(InputCom): 쥳ֹλ꤬ޤ\n") ;
      return 0 ;
    }  
    cp = skip_a_word(ary[1]) ;
    cp = skip_non_sp( cp ) ;
    if ( cp != NULL && *cp == '>' ) 
      cp++ ;
    ary[2] = skip_non_sp( cp ) ;
    cp = skip_a_word(ary[2]) ;
    if ( cp != NULL && *cp != '\0' ) 
      *cp = '\0' ;
    return 20 ;            /* ꤵ줿쥳ɣɣĤξɽ */
  }
  if (*cp == 'T' || *cp == 't' ) {
    ary[1] = skip_non_sp( cp + 1 ) ;
    if ( ary[1] == NULL ) {
      fprintf(stderr,"ERROR(InputCom): ƥֹλ꤬ޤ\n") ;
      return 0 ;
    }  
    cp = skip_a_word(ary[1]) ;
    cp = skip_non_sp( cp ) ;
    if ( *cp == '>' ) 
      cp++ ;
    ary[2] = skip_non_sp( cp ) ;
    cp = skip_a_word(ary[2]) ;
    if ( cp != NULL && *cp != '\0' )
      *cp = '\0' ;
    return 25 ;            /* ꤵ줿ƥֹξɽ */
  }
  if ( *cp == 'B' || *cp == 'b' ) {
    cp++ ;
    if ( *cp == '\0' || skip_non_sp( cp ) == NULL ) 
      RecoverCurentRec() ;
    return 0 ;
  }
  /* Default FH */
  ary[1] = skip_non_sp( cp ) ;
  cp = skip_a_word(ary[1]) ;
  if ( cp != NULL && *cp != '\0' ) {
    *cp = '\0' ;
    cp++ ;
  }
  ary[2] = skip_non_sp( cp ) ;
  return 1 ;
}






/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS ****************(Current Record = %d)\n",CurRecCt) ;
  fprintf( stderr,"FH  headword [pos]   ɽ[+ʻ]ˤ룱\n") ;
  fprintf( stderr,"FC  ConceptID        ǰɣĤˤ룱\n") ;

  fprintf( stderr,"SH  headword         ɽˤ룲\n") ;
  fprintf( stderr,"SC  ConceptID        ǰɣĤˤ룲\n") ;

  fprintf( stderr,"I   RID [file]       쥳IDˤɽؼ\n") ;
//  fprintf( stderr,"T   TID [file]       ƥIDˤɽؼ\n") ;
  fprintf( stderr,"P   [file]           ȥ쥳ɤɽ\n") ;
  fprintf( stderr,"PM  {FV}/EDR         ץȥ⡼ɤ\n") ;
  fprintf( stderr,"B                    θ̤᤹\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr,"\n") ;
}




int InitEnv()
{
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= OUT_V ;             /* ɽ⡼:FIELD/VALUEɽ⡼ɤ */
  return 1 ;
}



/* ɽ⡼ɤ */
void SetPrintMode( char *cp )
{
  cp = skip_non_sp( cp ) ;

  if ( cp != NULL ) {
    if ( ( strncmp(cp,"EDR",3) == 0 ||
           strncmp(cp,"edr",3) == 0 ) && *(cp+3) <= ' ') {
      ENV_FLAGS |= OUT_EDR ;
      return ;
    }
  }
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= OUT_V ;             /* ɽ⡼:FIELD/VALUEɽ⡼ɤ */
}







void print_CurRecord( char *recid, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  char dict[32], ids[32] ;
  int  ret , id ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_Record):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }
  if ( *recid == 'J' || *recid == 'T' )
    id = GetCode2Wid( recid, dict, ids) ;
  else 
    id = atoi( recid ) ;

  if ( id  < 1000000 ) {  /* EDR CORPUS DATA */
    if ( ( ENV_FLAGS & OUT_EDR ) != 0 ) {
      print_EDR_Format( fp, id ) ;
    }
    else {
      print_PP_Format( fp, id ) ;
    }
  }
  else {                 /* TEI DATA */
    print_TEI_Format( fp, id ) ;
  }
  fprintf(fp,"\n") ;
  if ( flag != 0 )
    fclose( fp ) ;
}



void print_CurRecords( char *ct, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  int  ret , ii, jj, kk, morct ;

  if ( file == NULL || *file == '\0' )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_CurRecord):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }

  if ( ct == NULL || *ct == '\0' )
    morct = -1 ;
  else 
    morct = atoi(ct) ;

  for ( ii = 0 ; ii < CurRecCt ; ii++) {

    if ( morct != -1 ) {
      if ( ii != 0 && ( ii % morct ) == 0 ) {
        ret = SuspendView(ii, CurRecCt) ;
        if ( ret < 0 ) 
          break ;
      }
    }
    if ( CurRecIDs[ii] < 1000000 ) {  /* EDR CORPUS DATA */
      if ( ( ENV_FLAGS & OUT_EDR ) != 0 ) {
        print_EDR_Format( fp, CurRecIDs[ii] ) ;
      }
      else {
        print_PP_Format( fp, CurRecIDs[ii] ) ;
      }
    }
    else {                 /* TEI DATA */
      print_TEI_Format( fp, CurRecIDs[ii] ) ;
    }
    fprintf(fp,"\n") ;

  }

  if ( flag != 0 )
    fclose( fp ) ;


}


int SuspendView(int cur, int total)
{
  char work[256] ;

  work[0] = '\0' ;
  fprintf(stderr,"### Continue? (%d/%d) [Yes]/No\n",cur,total) ;
  gets( work )  ;

  if ( work[0] == 'N' )
    return -1 ;

  return total ;
}




void print_CurRecordt( char *textid, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  char work[1024] ;
  int  ret , id ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_Record):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }
  
  ret = Get_IXT( TID2JCORPRecID, textid, strlen( textid ), work, 1024 ) ;
  if ( ret > 0 ) {

    id = get4byte( work ) ;
    if ( id < 1000000 ) {  /* EDR CORPUS DATA */
      if ( ( ENV_FLAGS & OUT_EDR ) != 0 ) {
        print_EDR_Format( fp, id ) ;
      }
      else {
        print_PP_Format( fp, id ) ;
      }
    }
    else {                 /* TEI DATA */
      print_TEI_Format( fp, id ) ;
    }
  }
  fprintf(fp,"\n") ;
  if ( flag != 0 )
    fclose( fp ) ;
}





int print_EDR_Format( FILE *fp, int id ) 
{
 int ret ;

  
  ret = PrnEDRFJCorpRecBu( fp, JCORPRecId2Val, id, 0x07 ) ;
  if ( ret <= 0 )
    return 0;

  ret = PrnEDRFJCorpRecWd( fp, JCORPRecId2Val, id ) ;

  /* ret = PrnEDRFJCorpRecGg( fp, JCORPRecId2Val, id ) ; */

  ret = PrnEDRFJCorpRecSt( fp, JCORPRecId2Val, id ) ;

  ret = PrnEDRFJCorpRecIm( fp, JCORPRecId2Val, id ) ;

  ret = PrnJCorpRecETC( fp, JCORPRecId2Val, id) ;

  return ret ;
}



int print_PP_Format( FILE *fp, int id )
{
  int ret ;

  ret = PrnEDRJCorpRecBu( fp, JCORPRecId2Val, id, 0x07 ) ;
  if ( ret <= 0 )
    return 0;

  ret = PrnEDRJCorpRecWd( fp, JCORPRecId2Val, id ) ;

  ret = PrnEDRJCorpRecSt( fp, JCORPRecId2Val, id ) ;

  ret = PrnEDRJCorpRecIm( fp, JCORPRecId2Val, id ) ;

  ret = PrnEDRJCorpRecRE( fp, JCORPRecId2Val, id) ;

  return ret ;
}



int print_TEI_Format( FILE *fp, int id )
{
  int ret ;

  ret = PrnTEIRID( fp, JCORPRecId2Val, id ) ;

  ret = PrnTEIHeader( fp, JCORPRecId2Val, id ) ;

  ret = PrnTEIText( fp, JCORPRecId2Val, id ) ;

  ret = PrnTEIHIndex( fp, JCORPRecId2Val, id ) ;

  return ret ;
}


