/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

/****************************************************************
    ʸˡμФ빹Υݡȴؿ
****************************************************************/

/****************************************************************
*   ɲϿݡ
*   USAGE:		AddJWD_report( FILE *fp, char **cary, int gid, int gids)
*   SYNOPSIS:		FILE  *fp    (IN)   ݡȽեݥ
*                       char  **cary (IN)   쥳:ǼγƥեɤؤΥݥ
*                       int   gid    (IN)   °륰롼ID
*                       int   gids   (IN)   Ϣ줬°륰롼ID(arg3ޤ)
*                       
*   DESCRIPTION:	
*	쥳ɤξȽ°륰롼פξɽ롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
void AddJWD_report( FILE *fp, char **cary, int *gids, int ct)
{
  int gid ;
  int ii, jj, ll, len, id, ret ;
  char  work[8192], buff[8192] ;

  if ( cary[5] == NULL ||
        strcmp( cary[5], "\"\"") == 0 ||
        strcmp( cary[5], "00000004") == 0 ) {
    /* 쥳ɤϤ */
    fprintf( fp, "==========================================================\n") ;
    ret = PrEDRJWDsub( fp, 'B', cary[0] , cary) ;
    return  ;
  }
  
  if ( ct == 0 ) {
    fprintf( fp, "==========================================================\n") ;
    ret = PrEDRJWDsub( fp, 'B', cary[0], cary) ;
    fprintf( fp, "----------------------------------------------------------\n") ;
    fprintf( fp, "----------------------------------------------------------\n") ;
    return  ;
  }

  fprintf( fp, "==========================================================\n") ;
  ret = PrEDRJWDsub( fp, 'B', cary[0], cary) ;

  for( jj = 0 ; jj < ct ; jj++) {
    fprintf( fp, "----------------------------------------------------------\n") ;
    len = Get_IXT( GrpID2RID, (char *)(gids+jj) , 4, buff, 8192) ;
    if ( len == 0 ) {
      printf("ERROR(AddJWD_report)GID[%d]=>Rid ??????\n", id) ;
      continue ;
    }
    for( ii = 0 ; ii < len  ; ii += 4 ) {
      id = get4byte( &buff[ii] ) ;
      ll = Get_IXT( WdRID2Val, (char *)&id, 4, work, 8192) ;
      if ( ll == 0 ) {
        printf("ERROR(AddJWD_report)RID[%d]=>Record ??????\n", id) ;
        continue ;
      }
      PrRid2VEDRJWD( fp, 'B', (char *)&id, 4, work, ll)  ;
    }
  }
  return  ;
}









/* 쥳ֹμɽ */
int UpdJWD_report1( FILE *fp, int Rid ) 
{
  char  buff[8192], buff2[8192] ;
  char  work1[1024] ;
  int   ii, id, jj, kk, ll, ret = 0 ;
  int   len, gid ;
  char  *cary[64] ;

  if ( RID2GrpID == NULL )
    return -1 ;
  if ( WdRID2Val == NULL )
    return -1 ;
  if ( GrpID2RID == NULL )
    return -1 ;

  ll = Get_IXT( RID2GrpID , (char *)&Rid, 4, buff2, 8192 ) ;
  if ( ll == 0 ) {
    printf("ERROR(UpdJWD_report1)RID[%d]=>Gid ??????\n", id) ;
    return -1 ;
  }
  gid = get4byte( buff2 ) ;

  len = Get_IXT( GrpID2RID, (char *)&gid , 4, buff, 8192) ;
  if ( len == 0 ) {
    printf("ERROR(UpdJWD_report1)GID[%d]=>Rid ??????\n", id) ;
    return -1 ;
  }
  fprintf( stderr,"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< GID[%07d]\n",gid ) ;
  for( ii = 0 ; ii < len  ; ii += 4 ) {
    id = get4byte( &buff[ii] ) ;
    ll = Get_IXT( WdRID2Val, (char *)&id, 4, buff2, 8192) ;
    if ( ll == 0 ) {
      printf("ERROR(UpdJWD_report1)RID[%d]=>Record ??????\n", id) ;
      continue ;
    }
    ret = StartPts( buff2, ll, cary) ;
      //        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
      //        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
      //
      //           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
      //           |  (n)           | (n)    | (n)    | (n)    | (n)        |


    /* ñɽ */
    GetSyuushi( cary, work1, 1024 ) ;

    /* 쥳ɣɣ ñɽ ɤ ʻ ǰ̻  */
    fprintf( fp,"JWD%07d\t%s\t%s\t%s\t%s\n",id,work1,cary[7],J_POS[*cary[3]].type1,cary[5]) ;

  }     
  return gid;
}







/* 쥳ֹμɽ */
void UpdJWD_report2( FILE *fp, int *gids, int ct)
{
  char  buff[8192] ;
  char  work[1024], work1[1024] ;
  int   ii, id, jj, kk, ll, ret = 0 ;
  int   len, gid ;
  char  *cary[64] ;

  if ( RID2GrpID == NULL )
    return  ;
  if ( WdRID2Val == NULL )
    return  ;
  if ( GrpID2RID == NULL )
    return  ;

  if ( ct <= 0 ) {
    fprintf( stderr,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> GID[%07d] (NEW_ID)\n", gids[0] ) ;
    fprintf( stderr,"\n" ) ;
    return ;
  }
  fprintf( stderr,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> GID[%07d]\n", gids[0] ) ;
  len = Get_IXT( GrpID2RID, (char *)(gids) , 4, buff, 8192) ;
  if ( len == 0 ) {
    printf("ERROR(UpdJWD_report2)GID[%d]=>Rid ??????\n", id) ;
    return ;
  }
  for( ii = 0 ; ii < len  ; ii += 4 ) {
    id = get4byte( &buff[ii] ) ;
    ll = Get_IXT( WdRID2Val, (char *)&id, 4, work, 8192) ;
    if ( ll == 0 ) {
      printf("ERROR(UpdJWD_report2)RID[%d]=>Record ??????\n", id) ;
      continue ;
    }
    ret = StartPts( work, ll, cary) ;
      //        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
      //        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
      //
      //           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
      //           |  (n)           | (n)    | (n)    | (n)    | (n)        |


    /* ñɽ */
    GetSyuushi( cary, work1, 1024 ) ;

    /* 쥳ɣɣ ñɽ ɤ ʻ ǰ̻  */
    fprintf( fp,"JWD%07d\t%s\t%s\t%s\t%s\n",id,work1,cary[7],J_POS[*cary[3]].type1,cary[5]) ;
  }     
  fprintf( fp ,"\n") ;
  return ;
}





/* ˴ؤ뽤Ƥɽ */
void UpdJWD_report0( FILE *fp, int Rid, char **cary, char **oary)
{
  char  work1[1024] ;

  if ( RID2GrpID == NULL )
    return  ;
  if ( WdRID2Val == NULL )
    return  ;
  if ( GrpID2RID == NULL )
    return  ;

   /* ñɽ */
   GetSyuushi( oary, work1, 1024 ) ;

   /* 쥳ɣɣ ñ츫Ф ɤ ʻ ǰ̻  */
   fprintf( fp,"JWD%07d\t",Rid) ;
   fprintf( fp,"%s\t%s\t%s\t%s\t =>\t",work1,oary[7],J_POS[*oary[3]].type1,oary[5]) ;

   /* ñɽ */
   GetSyuushi( cary, work1, 1024 ) ;
   /* ñ츫Ф ɤ ʻ ǰ̻  */
   fprintf( fp,"%s\t%s\t%s\t%s\n\n",work1,cary[7],J_POS[*cary[3]].type1,cary[5]) ;

  return ;
}



/* ˴ؤ뽤Ƥɽ */
void UpdJWD_reportDel( FILE *fp, int Rid, char **oary)
{
  char  work1[1024] ;

  if ( RID2GrpID == NULL )
    return  ;
  if ( WdRID2Val == NULL )
    return  ;
  if ( GrpID2RID == NULL )
    return  ;

   /* ñɽ */
   GetSyuushi( oary, work1, 1024 ) ;

   /* 쥳ɣɣ ñ츫Ф ɤ ʻ ǰ̻  */
   fprintf( fp,"JWD%07d\t",Rid) ;
   fprintf( fp,"%s\t%s\t%s\t%s\t => DELETE\n",work1,oary[7],J_POS[*oary[3]].type1,oary[5]) ;

  return ;
}




