/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  JCorpusPOS[]= {
	{ "̾",	 "̾	Noun" },
	{ "ư",	 "ư	Verb" },
	{ "ƻ",	 "ƻ	Adjective" },
	{ "ư",	 "ư	Adjectival noun" },
	{ "",	 "	Adverb" },
	{ "Ϣλ",	 "Ϣλ	Adnominal" },
	{ "³",	 "³	Conjunction" },
	{ "Ƭ",	 "Ƭ	Prefix" },
	{ "",	 "	Suffix" },
	{ "",	 "	Ending" },
	{ "",	 "	Particle" },
	{ "ư",	 "ư	Auxiliary verb" },
	{ "ư",	 "ư	Interjection" },
	{ "",	 "	Symbol" },
	{ "",	 "	Number" },
	{ "ɽ",	 "ɽ	Notation error" },
	{ NULL,	 NULL }} ;


CharTable  ECorpusPOS[]= {
	{ "NOUN",	 "̾	Noun" },
	{ "PRON",	 "̾	Pronoun" },
	{ "DEMO",	 "ؼ" },
	{ "INDEF",	 "	Indefinite word" },
	{ "WH",	 	 "WH-	Wh-word" },
	{ "VI",	 	 "ư	Intransitive verb" },
	{ "VT",	 	 "¾ư	Transitive verb" },
	{ "VERB",	 "ư	Verb" },
	{ "BE",	 	 "BEư	Be verb" },
	{ "ADJ",	 "ƻ	Adjective" },
	{ "ADV",	 "	Adverb" },
	{ "PTCL",	 "쾮	Adverbial particle" },
	{ "CONJ",	 "³	Conjunction" },
	{ "PF",	 	 "Ƭ	Prefix" },
	{ "SUF",	 "	Suffix" },
	{ "ART",	 "	Article" },
	{ "AUX",	 "ư	Auxiliary verb" },
	{ "PREP",	 "ֻ	Preposition" },
	{ "ITJ",	 "	Interjection" },
	{ "BLNK",	 "	Blank" },
	{ "PUNC",	 "ڤ국	Punctuation mark" },
	{ "SYM",	 "	Symbol" },
	{ "UNIT",	 "ñ	Unit" },
	{ "NUM",	 "	Number" },
	{ "AP",	 	 "ɽ	Notation error" },
	{ NULL,	 NULL }} ;






