/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

/*  Ѿơ֥ */
CharTable  J_conjugations[]= {
	{ "JRN4",	 "̾	Verbal nouns" },
	{ "JRVK",	 "Ըʳ	K-consonant `go-dan' conjugation verb stems" },
	{ "JRVG",	 "Ըʳ	G-consonant `go-dan' conjugation verb stems" },
	{ "JRVS",	 "Ըʳ	S-consonant `go-dan' conjugation verb stem" },
	{ "JRVT",	 "Ըʳ	T-consonant `go-dan' conjugation verb stems" },
	{ "JRVN",	 "ʹԸʳ	N-consonant `go-dan' conjugation verb stems" },
	{ "JRVB",	 "йԸʳ	B-consonant `go-dan' conjugation verb stems" },
	{ "JRVM",	 "޹Ըʳ	M-consonant `go-dan' conjugation verb stems" },
	{ "JRVR",	 "Ըʳ	R-consonant `go-dan' conjugation verb stems" },
	{ "JRVW",	 "Ըʳ	W-consonant `go-dan' conjugation verb stems" },
	{ "JRV1",	 "ʾ塦˰ʳ	`Ichi-dan' conjugation verb stems " },
	{ "JRV2",	 "ѳʳ	S-consonant irregular conjugation verb stems" },
	{ "JRV3",	 "ѳʳ	Z-consonant irregular conjugation verb stems" },
	{ "JRV4",	 "ѳʳ	K-consonant irregular conjugation verb stems" },
	{ "JRV5",	 "	`Iku' conjugation verb stems" },
	{ "JRV6",	 "	`Aru' conjugation verb stems" },
	{ "JRV7",	 "å	`Ossharu ' conjugation verb stems" },
	{ "JRA1",	 "ƻ 1	Adjective stems" },
	{ "JRA2",	 "ƻ 2	Adjective stems endingin the `i'-vowel" },
	{ "JRA3",	 "ƻ 3	Stems of the Aux. verbʤ" },
	{ "JRM1",	 "ư 1	D-consonant conjugation adjectival noun stems 1" },
	{ "JRM2",	 "ư 2	D-consonant conjugation adjectival noun stems 2 " },
	{ "JRM3",	 "ư 3	D-consonant conjugation  adjectival noun stems 3" },
	{ "JRM4",	 "ư 4	D-consonant conjugation  adjectival noun stems 4" },
	{ "JRMA",	 "ư 5	D-consonant conjugation  adjectival noun stems A" },
	{ "JRM5",	 "ư 6	D-consonant conjugation  adjectival noun stems 5" },
	{ "JRM9",	 "ư 7	D-consonant conjugation adjectival noun stems 9" },
	{ "JRM7",	 "ư쥿ȳ 1	`Taruto' conjugation adjectival noun stems" },
	{ "JRM8",	 "ư쥿ȳ 2	`Taruto' conjugation adjectival noun stems 8 ending in " },



	{ "JMIZEN",	 "̤	Subjunctive form" },
	{ "JRENYOU",	 "Ϣѷ	Infinitive form" },
	{ "JRENYOU-NI",	 "ưϢѷ	Adjectival noun infinitive form" },
	{ "JRENYOU-DE",	 "ưϢѷ	Adjectival noun infinitive form" },
	{ "JSHUUSHI",	 "߷	Predicative form" },
	{ "JSHUU-TAI",	 "ߡϢƱ	Predicative-adnominal identical form" },
	{ "JRENTAI",	 "Ϣη	Adnominal form" },
	{ "JKATEI",	 "	Conditional form" },
	{ "JMEIREI",	 "̿	Imperative form" },
        { NULL,  NULL }} ;


