/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"


CharTable  JCorpusREL[]= {
	{ "a-object",     "That which has a particular attribute"},
	{ "agent",   "That which acts on its own volition and is the subject that brings about"},
	{ "and",     "Coordination between concepts"},
	{ "basis",   "That which is used as the standard of comparison"},
	{ "beneficiary",  "Beneficiary (receiver) of an action or occurrence"},
        { "cause",         " " },
	{ "condition",    "Condition of an occurrence or fact"},
	{ "cooccurrence", "Simultaneous occurrence of events or actions"},
        { "degree",        " " },
        { "duration",      " " },
        { "element-of",    " " },
	{ "from-to", "Range of items specified"},
	{ "goal",    "Location from which an event or occurrence ends"},
	{ "implement",    "That which is used in a voluntary action such as tools or other implements"},
        { "location",      " " },
	{ "manner",  "Way in which an action or change occurrs"},
	{ "material",     "That which is used to make up something"},
	{ "modifier",     "Modification"},
	{ "number",  "Number"},
	{ "object",  "That which is affected by an action or change"},
	{ "or",      "Selection between concepts"},
        { "part-of",       " " },
	{ "place",   "Place (physical location) at which something occurs"},
	{ "purpose", "Purpose or reason for an action or occurrence"},
	{ "possessor",    "Possession or ownership"},
	{ "quantity",     "Amount (quantity) of a thing, action, or change"},
	{ "scene",   "Place (abstract location) at which something occurs"},
	{ "sequence",     "Sequential occurrence of events or actions"},
	{ "source",  "Location from which an event or occurrence begins"},
	{ "time",    "Time at which something occurrs"},
	{ "time-from",    "Time at which something begins"},
	{ "time-to", "Time at which something ends"},
	{ "unit",    "Unit"},
	{ NULL,	 NULL }} ;


