/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

/*  ǽ */
CharTable  J_funcword[]= {
	{ "JJBA",	 "ڤС	ParticlesڤС" },
	{ "JJBAKARI",	 "ڤФ	ParticlesڤФ" },
	{ "JJDAKE",	 "ڤ	Particlesڤ" },
	{ "JJDANO",	 "ڤΡ	ParticlesڤΡ" },
	{ "JJDATTE",	 "ڤäơ	Particlesڤäơ" },
	{ "JJDE",	 "ڤǡ	Particlesڤǡ" },
	{ "JJDEMO",	 "ڤǤ	ParticlesڤǤ" },
	{ "JJDOKOROKA",	 "ڤɤ	Particlesڤɤ" },
	{ "JJGA",	 "ڤ	Particlesڤ" },
	{ "JJHA",	 "ڤϡ	Particlesڤϡ" },
	{ "JJHE",	 "ڤء	Particlesڤء" },
	{ "JJHODO",	 "ڤۤɡ	Particlesڤۤɡ" },
	{ "JJHOKA",	 "ڤۤ	Particlesڤۤ" },
	{ "JJKA",	 "ڤ	Particlesڤ" },
	{ "JJKAI",	 "ڤ	Particlesڤ" },
	{ "JJKAMO",	 "ڤ	Particlesڤ" },
	{ "JJKANA",	 "ڤʡ	Particlesڤʡ" },
	{ "JJKARA",	 "ڤ	Particlesڤ" },
	{ "JJKASHIRA",	 "ڤ	Particlesڤ" },
	{ "JJKEREDOMO",	 "ڤɤ⡢ɡ	Particlesڤɤ⡢ɡ" },
	{ "JJKIRI",	 "ڤ	Particlesڤ" },
	{ "JJKOSO",	 "ڤ	Particlesڤ" },
	{ "JJKURAI",	 "ڤ餤餤	Particlesڤ餤餤" },
	{ "JJKUSENI",	 "ڤˡ	Particlesڤˡ" },
	{ "JJMADE",	 "ڤޤǡ	Particlesڤޤǡ" },
	{ "JJMO",	 "ڤ	Particlesڤ" },
	{ "JJMONO",	 "ڤΡ	ParticlesڤΡ" },
	{ "JJMONOKA",	 "ڤΤ	ParticlesڤΤ" },
	{ "JJMONONO",	 "ڤΤΡ	ParticlesڤΤΡ" },
	{ "JJNA",	 "ڤ(ػ)	Particlesڤ(ػ)" },
	{ "JJNAA",	 "ڤʡʤ(ư)	Particlesڤʡʤ(ư)" },
	{ "JJNADO",	 "ڤʤɡ	Particlesڤʤɡ" },
	{ "JJNAGARA",	 "ڤʤ	Particlesڤʤ" },
	{ "JJNANKA",	 "ڤʤ󤫡	Particlesڤʤ󤫡" },
	{ "JJNANTE",	 "ڤʤơ	Particlesڤʤơ" },
	{ "JJNARA",	 "ڤʤ	Particlesڤʤ" },
	{ "JJNARADEHA",	 "ڤʤǤϡ	ParticlesڤʤǤϡ" },
	{ "JJNARI",	 "ڤʤ(³)	Particlesڤʤ(³)" },
	{ "JJNEE",	 "ڤͤ͡	Particlesڤͤ͡" },
	{ "JJNI",	 "ڤˡ	Particlesڤˡ" },
	{ "JJNITE",	 "ڤˤơ	Particlesڤˤơ" },
	{ "JJNO",	 "ڤΡ	ParticlesڤΡ" },
	{ "JJNODE",	 "ڤΤǡ	ParticlesڤΤǡ" },
	{ "JJNOMI",	 "ڤΤߡ	ParticlesڤΤߡ" },
	{ "JJNONI",	 "ڤΤˡ	ParticlesڤΤˡ" },
	{ "JJSAE",	 "ڤ	Particlesڤ" },
	{ "JJSA",	 "ڤ	Particlesڤ" },
	{ "JJSHI",	 "ڤ	Particlesڤ" },
	{ "JJSHIKA",	 "ڤ	Particlesڤ" },
	{ "JJSHIMO",	 "ڤ	Particlesڤ" },
	{ "JJSURA",	 "ڤ	Particlesڤ" },
	{ "JJTARA",	 "ڤ顢	Particlesڤ顢" },
	{ "JJTARI",	 "ڤꡢ	Particlesڤꡢ" },
	{ "JJTATTE",	 "ڤäơäơ	Particlesڤäơäơ" },
	{ "JJTE",	 "ڤơǡ	Particlesڤơǡ" },
	{ "JJTEHA",	 "ڤƤϡǤϡ	ParticlesڤƤϡǤϡ" },
	{ "JJTEMO",	 "ڤƤ⡢Ǥ	ParticlesڤƤ⡢Ǥ" },
	{ "JJTO",	 "ڤȡ	Particlesڤȡ" },
	{ "JJTOKA",	 "ڤȤ	ParticlesڤȤ" },
	{ "JJTOKORODE",	 "ڤȤǡ	ParticlesڤȤǡ" },
	{ "JJTOKOROGA",	 "ڤȤ	ParticlesڤȤ" },
	{ "JJTOMO",	 "ڤȤ	ParticlesڤȤ" },
	{ "JJTOTE",	 "ڤȤơ	ParticlesڤȤơ" },
	{ "JJTSUTSU",	 "ڤĤġ	ParticlesڤĤġ" },
	{ "JJTTE",	 "ڤäơ	Particlesڤäơ" },
	{ "JJTTEBA",	 "ڤäƤС	ParticlesڤäƤС" },
	{ "JJWA",	 "ڤ	Particlesڤ" },
	{ "JJWO",	 "ڤ	Particlesڤ" },
	{ "JJYA",	 "ڤ	Particlesڤ" },
	{ "JJYAINAYA",	 "ڤ䤤ʤ	Particlesڤ䤤ʤ" },
	{ "JJYARA",	 "ڤ	Particlesڤ" },
	{ "JJYO",	 "ڤ衢褦	Particlesڤ衢褦" },
	{ "JJYORI",	 "ڤ	Particlesڤ" },
	{ "JJYUE",	 "ڤ椨	Particlesڤ椨" },
	{ "JJZE",	 "ڤ	Particlesڤ" },
	{ "JJZO",	 "ڤ	Particlesڤ" },
	{ "JJZUTU",	 "ڤġ	Particlesڤġ" },
	{ "JJKATAWARA",	 "ڤ	Particlesڤ" },
	{ "JJDO",	 "ڤɡ	Particlesڤɡ" },
	{ "JJMONOYUE",	 "ڤΤ椨	ParticlesڤΤ椨" },
	{ "JJDOKORO",	 "ڤɤ	Particlesڤɤ" },
	{ "JJZUTSU",	 "ڤŤġ	ParticlesڤŤġ" },

	{ "JNIATARU",	 "ڤˤ	Particle-equivalent  wordsڤˤ" },
	{ "JNIATATTE",	 "ڤˤäơ	Particle-equivalent  wordsڤˤäơ" },
	{ "JNIKAKAWARAZU",	 "ڤˤ餺	Particle-equivalent  wordsڤˤ餺" },
	{ "JNIKANSHI",	 "ڤ˴ؤ˴ؤơ	Particle-equivalent  wordsڤ˴ؤ˴ؤơ" },
	{ "JNIKANSURU",	 "ڤ˴ؤ	Particle-equivalent  wordsڤ˴ؤ" },
	{ "JNIKAWATTE",	 "ڤˤäơ	Particle-equivalent  wordsڤˤäơ" },
	{ "JNIMOKAKAWARAZU",	 "ڤˤ⤫餺	Particle-equivalent  wordsڤˤ⤫餺" },
	{ "JNIMOTODUKU",	 "ڤ˴Ť	Particle-equivalent  wordsڤ˴Ť" },
	{ "JNIOITE",	 "ڤˤơ	Particle-equivalent  wordsڤˤơ" },
	{ "JNIOKERU",	 "ڤˤ	Particle-equivalent  wordsڤˤ" },
	{ "JNIOUZI",	 "ڤ˱˱ơ	Particle-equivalent  wordsڤ˱˱ơ" },
	{ "JNISAISHI",	 "ڤ˺ݤ˺ݤơ	Particle-equivalent  wordsڤ˺ݤ˺ݤơ" },
	{ "JNISHITAGATTE",	 "ڤ˽˽äơ	Particle-equivalent  wordsڤ˽˽äơ" },
	{ "JNISHITEMO",	 "ڤˤƤ	Particle-equivalent  wordsڤˤƤ" },
	{ "JNISOTTE",	 "ڤˤäơˤ	Particle-equivalent  wordsڤˤäơˤ" },
	{ "JNITAISHITE",	 "ڤФơФ	Particle-equivalent  wordsڤФơФ" },
	{ "JNITAISURU",	 "ڤФ	Particle-equivalent  wordsڤФ" },
	{ "JNITOMONATTE",	 "ڤȼäơȼ	Particle-equivalent  wordsڤȼäơȼ" },
	{ "JNITOMONAU",	 "ڤȼ	Particle-equivalent  wordsڤȼ" },
	{ "JNITOTTE",	 "ڤˤȤäơˤȤ	Particle-equivalent  wordsڤˤȤäơˤȤ" },
	{ "JNITSUITE",	 "ڤˤĤơˤĤ	Particle-equivalent  wordsڤˤĤơˤĤ" },
	{ "JNITSURE",	 "ڤˤĤ졢ˤĤơ	Particle-equivalent  wordsڤˤĤ졢ˤĤơ" },
	{ "JNIWATARU",	 "ڤˤ錄	Particle-equivalent  wordsڤˤ錄" },
	{ "JNIWATATTE",	 "ڤˤ錄äơ	Particle-equivalent  wordsڤˤ錄äơ" },
	{ "JNIYORU",	 "ڤˤ	Particle-equivalent  wordsڤˤ" },
	{ "JNIYOTTE",	 "ڤˤäơˤ	Particle-equivalent  wordsڤˤäơˤ" },
	{ "JNOYOUNA",	 "ڤΤ褦ʡ	Particle-equivalent  wordsڤΤ褦ʡ" },
	{ "JNOYOUNI",	 "ڤΤ褦ˡ	Particle-equivalent  wordsڤΤ褦ˡ" },
	{ "JTOIU",	 "ڤȤ	Particle-equivalent  wordsڤȤ" },
	{ "JTOSHITE",	 "ڤȤơȤ	Particle-equivalent  wordsڤȤơȤ" },
	{ "JTOSUREBA",	 "ڤȤС	Particle-equivalent  wordsڤȤС" },
	{ "JTOSURU",	 "ڤȤ	Particle-equivalent  wordsڤȤ" },
	{ "JTOTOMONI",	 "ڤȤȤˡ	Particle-equivalent  wordsڤȤȤˡ" },
	{ "JWOBA",	 "ڤС	Particle-equivalent  wordsڤС" },
	{ "JWOKAISHITE",	 "ڤ𤷤ơ𤷡	Particle-equivalent  wordsڤ𤷤ơ𤷡" },
	{ "JWOKAISURU",	 "ڤ𤹤	Particle-equivalent  wordsڤ𤹤" },
	{ "JWOMOTTE",	 "ڤäơ	Particle-equivalent  wordsڤäơ" },
	{ "JWOSHITE",	 "ڤ򤷤ơ	Particle-equivalent  wordsڤ򤷤ơ" },
	{ "JWOTOOSHITE",	 "ڤ̤ơ	Particle-equivalent  wordsڤ̤ơ" },
	{ "JWOTSUKATTE",	 "ڤȤäơȤ	Particle-equivalent  wordsڤȤäơȤ" },
	{ "JNIKANSHITE",	 "ڤ˴ؤơ	Particle-equivalent  wordsڤ˴ؤơ" },
	{ "JNITSURETE",	 "ڤˤĤơ	Particle-equivalent  wordsڤˤĤơ" },
	{ "JNIOUJITE",	 "ڤ˱ơ	Particle-equivalent  wordsڤ˱ơ" },
	{ "JNIMOTODUITE",	 "ڤ˴Ťơ	Particle-equivalent  wordsڤ˴Ťơ" },
	{ "JNISAISHITE",	 "ڤ˺ݤơ	Particle-equivalent  wordsڤ˺ݤơ" },

	{ "JBESHI",	 "ưڤ٤	Auxiliary verbڤ٤" },
	{ "JDA",	 "ưڤ	Auxiliary verbڤ" },
	{ "JDESU",	 "ưڤǤ	Auxiliary verbڤǤ" },
	{ "JMAI",	 "ưڤޤ	Auxiliary verbڤޤ" },
	{ "JMASU",	 "ưڤޤ	Auxiliary verbڤޤ" },
	{ "JNAI",	 "ưڤʤ	Auxiliary verbڤʤ" },
	{ "JNU",	 "ưڤ̡	Auxiliary verbڤ̡" },
	{ "JRASHII",	 "ưڤ餷	Auxiliary verbڤ餷" },
	{ "JRERU",	 "ưڤ롢	Auxiliary verbڤ롢" },
	{ "JSERU",	 "ưڤ롢	Auxiliary verbڤ롢" },
	{ "JSOUDA1",	 "ưڤ(ʹ)	Auxiliary verbڤ(ʹ)" },
	{ "JSOUDA2",	 "ưڤ()	Auxiliary verbڤ()" },
	{ "JTA",	 "ưڤ	Auxiliary verbڤ" },
	{ "JTAGARU",	 "ưڤ	Auxiliary verbڤ" },
	{ "JTAI",	 "ưڤ	Auxiliary verbڤ" },
	{ "JU",	 "ưڤ褦	Auxiliary verbڤ褦" },
	{ "JYOUDA",	 "ưڤ褦	Auxiliary verbڤ褦" },

	{ "JCHIGAINAI",	 "ưڰ㤤ʤ	Auxiliary  verb-equivalent wordsڰ㤤ʤ" },
	{ "JIKENAI",	 "ưڤʤ	Auxiliary  verb-equivalent wordsڤʤ" },
	{ "JKAGIRANAI",	 "ưڸ¤ʤ	Auxiliary  verb-equivalent wordsڸ¤ʤ" },
	{ "JKAMAWANAI",	 "ưڹʤ	Auxiliary  verb-equivalent wordsڹʤ" },
	{ "JKAMOSIRENAI",	 "ưڤ⤷ʤ	Auxiliary  verb-equivalent wordsڤ⤷ʤ" },
	{ "JKUDASAI",	 "ưڲ	Auxiliary  verb-equivalent wordsڲ" },
	{ "JMIERU",	 "ưڤߤ	Auxiliary  verb-equivalent wordsڤߤ" },
	{ "JMITAI",	 "ưڤߤ	Auxiliary  verb-equivalent wordsڤߤ" },
	{ "JNARANAI",	 "ưڤʤʤ	Auxiliary  verb-equivalent wordsڤʤʤ" },
	{ "JNASAI",	 "ưڤʤʤ	Auxiliary  verb-equivalent wordsڤʤʤ" },
	{ "JNASASUGIRU",	 "ưڤʤ	Auxiliary  verb-equivalent wordsڤʤ" },
	{ "JNEBANARANU",	 "ưڤͤФʤ̡	Auxiliary  verb-equivalent wordsڤͤФʤ̡" },
	{ "JOYOBANAI",	 "ưڵڤФʤ	Auxiliary  verb-equivalent wordsڵڤФʤ" },
	{ "JSASHITSUKAENAI",	 "ưڤĤʤ	Auxiliary  verb-equivalent wordsڤĤʤ" },
	{ "JSUGINAI",	 "ưڲ᤮ʤ	Auxiliary  verb-equivalent wordsڲ᤮ʤ" },
	{ "JTEAGERU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEARU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEHOSHII",	 "ưڤƤۤ	Auxiliary  verb-equivalent wordsڤƤۤ" },
	{ "JTEIKU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEIRU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEKURERU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEKURU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTEMIRU",	 "ưڤƤߤ	Auxiliary  verb-equivalent wordsڤƤߤ" },
	{ "JTEMORAU",	 "ưڤƤ餦	Auxiliary  verb-equivalent wordsڤƤ餦" },
	{ "JTEOKU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTESHIMAU",	 "ưڤƤޤ	Auxiliary  verb-equivalent wordsڤƤޤ" },
	{ "JTEYARU",	 "ưڤƤ	Auxiliary  verb-equivalent wordsڤƤ" },
	{ "JTSUTSUARU",	 "ưڤĤĤ	Auxiliary  verb-equivalent wordsڤĤĤ" },
	{ "JUTOSURU",	 "ưڤȤ	Auxiliary  verb-equivalent wordsڤȤ" },
	{ "JWAKENIIKANAI",	 "ưڤ櫓ˤʤ	Auxiliary  verb-equivalent wordsڤ櫓ˤʤ" },
	{ "JYARANU",	 "ưڤ̡	Auxiliary  verb-equivalent wordsڤ̡" },
	{ "JYOI",	 "ưڤ褤	Auxiliary  verb-equivalent wordsڤ褤" },
	{ "JZARUWOENAI",	 "ưڤ򤨤ʤ	Auxiliary  verb-equivalent wordsڤ򤨤ʤ" },
	{ "JZUNIIRARENAI",	 "ưڤˤʤ	Auxiliary  verb-equivalent wordsڤˤʤ" },

	{ "JAGEKU",	 "̾ڤ	Formal nounsڤ" },
	{ "JAIDA",	 "̾ڤ	Formal nounsڤ" },
	{ "JATARI",	 "̾դ	Formal nounsդ" },
	{ "JBAAI",	 "̾ھ	Formal nounsھ" },
	{ "JDAN",	 "̾ʡ	Formal nounsʡ" },
	{ "JHAME",	 "̾ڤϤᡢܡ	Formal nounsڤϤᡢܡ" },
	{ "JHAZU",	 "̾ڤϤ	Formal nounsڤϤ" },
	{ "JHODO",	 "̾ڤۤɡ	Formal nounsڤۤɡ" },
	{ "JHOKA",	 "̾ڤۤ	Formal nounsڤۤ" },
	{ "JHOU",	 "̾ڤۤ	Formal nounsڤۤ" },
	{ "JIGAI",	 "̾ڰʳ	Formal nounsڰʳ" },
	{ "JIJOU",	 "̾ڰʾ	Formal nounsڰʾ" },
	{ "JIPPOU",	 "̾ڰ	Formal nounsڰ" },
	{ "JKAGIRI",	 "̾ڤ	Formal nounsڤ" },
	{ "JKAWARI",	 "̾ڤꡢ	Formal nounsڤꡢ" },
	{ "JKEN",	 "̾ڷ	Formal nounsڷ" },
	{ "JKORO",	 "̾ڤ	Formal nounsڤ" },
	{ "JKOTO",	 "̾ڤȡ	Formal nounsڤȡ" },
	{ "JKURAI",	 "̾ڤ餤	Formal nounsڤ餤" },
	{ "JMAGIWA",	 "̾ڴֺݡ	Formal nounsڴֺݡ" },
	{ "JMAMA",	 "̾ڤޤޡ	Formal nounsڤޤޡ" },
	{ "JME",	 "̾ܡ	Formal nounsܡ" },
	{ "JMONO",	 "̾ڤΡ	Formal nounsڤΡ" },
	{ "JOKAGE",	 "̾ڤ	Formal nounsڤ" },
	{ "JORI",	 "̾ڤ	Formal nounsڤ" },
	{ "JSAMA",	 "̾ڤޡ͡	Formal nounsڤޡ͡" },
	{ "JSEI",	 "̾ڤ	Formal nounsڤ" },
	{ "JTABI",	 "̾ڤӡ١	Formal nounsڤӡ١" },
	{ "JTAME",	 "̾ڤᡢ١	Formal nounsڤᡢ١" },
	{ "JTOKI",	 "̾ڤȤ	Formal nounsڤȤ" },
	{ "JTOKORO",	 "̾ڤȤ	Formal nounsڤȤ" },
	{ "JTOORI",	 "̤̾	Formal nouns̤" },
	{ "JTOTAN",	 "̾ü	Formal nounsü" },
	{ "JTSUDO",	 "̾ڤĤɡ١	Formal nounsڤĤɡ١" },
	{ "JTSUMORI",	 "̾ڤĤ	Formal nounsڤĤ" },
	{ "JUCHI",	 "̾ڤ	Formal nounsڤ" },
	{ "JUE",	 "̾ڤ	Formal nounsڤ" },
	{ "JWAKE",	 "̾ڤ櫓	Formal nounsڤ櫓" },
	{ "JYASAKI",	 "̾	Formal nouns" },
	{ "JYOSHI",	 "̾ڤ褷ݡ	Formal nounsڤ褷ݡ" },
	{ "JYOU",	 "̾ڤ褦͡	Formal nounsڤ褦͡" },

	{ "JSUUZI",	 "	Numeral" },
	{ "JKETA1",	 "1	Base ten unit place figures in the decimal system (1)" },
	{ "JKETA2",	 "2	Base ten unit place figures in the decimal system (2)" },

	{ "JSETSUZOKU",	 "³ط	Non-coordinative conjunction" },
	{ "JHEIRETSU",	 "ط	Coordinative conjunction" },
        { NULL,  NULL }} ;




