#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main()
{
      int    flag ,ret ;
      int    jj, kk ;
      int    dct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      unsigned char   buff2[16386] ;
      char  work[10] ;
      char   *cary[30] ;
      CFile  *fpt , *dpt;
      int Rid ;

      char *wdenv ;
      char file[512] ;
      int  len ;

      InitEdrTbl() ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "TCPC_DB" ) ;
      fpt = Create_IXT( file, 'b', 10000 , -1, 64) ;

      strcpy( &file[len], "TCPC_IX" ) ;
      dpt = Create_IXT( file, 's', 10000 ,  6, 32) ;

      dct = 0 ;
      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( strncmp( buff, "TCPC", 3) != 0 ) {
            fprintf( stderr, "ERROR:[%s]\n",buff ) ;
            continue ;
	  }
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            /* system("date") ; */
          }
          /* printf("IN>[%s](%d)\n",buff,strlen(buff)) ;  */
          len = CreateCpcRec( buff, buff2, 16386 ) ;
          Rid = *(int *)buff2 ;
          ret = Put_IXT(fpt, buff2, 4, buff2, len) ;
          /* printf("Put_IXT(Rid=>CPC): ret=%d\n",ret) ; */
          StartPtsCPC(buff2, ret, cary) ;
          memcpy( work, buff2, 4 ) ;
          /* ̳ǰ쥳ֹ ɲ */
          work[4] = 0x02 ;
          ret = Add_IXT_DATA2( dpt, cary[1], strlen(cary[1]), work, 5) ;
          if ( ret <= 0 ) {
            fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[1],Rid) ;
            return  ;
          }
          /* ̳ǰ쥳ֹ ɲ */
          work[4] = 0x01 ;
          ret = Add_IXT_DATA2( dpt, cary[2], strlen(cary[2]), work, 5) ;
          if ( ret <= 0 ) {
            fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",cary[2],Rid) ;
            return ;
          }
          dct++ ;
          continue ;
      }
fprintf(stderr, "End Dump_IXT\n") ;
      Close_IXT( fpt ) ;
      Close_IXT( dpt ) ;
}



