#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"

/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997 *
*                                                                           *
*****************************************************************************
*/




int  ChkRecByCat( CFile *dt, int rid, int cat)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return -1;
   ret = Get_IXT(dt, (char *)&rid, 4, data, 8192) ;
   if ( ret == 0 )
     return  -1 ;
   //* ñ켭ǡ
   //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
   //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
   //*
   //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
   //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

   if ( *(data+6) == cat )
     return 1 ;
   return -1 ;
}





int  ChkRecByLRcon( CFile *dt, int rid, int lcon, int rcon)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return -1;
   ret = Get_IXT(dt, (char *)&rid, 4, data, 8192) ;
   if ( ret == 0 )
     return  -1 ;
   //* ñ켭ǡ
   //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
   //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
   //*
   //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
   //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

   if ( lcon != -1 && *(data+4) != lcon  )
     return -1 ;
   if ( rcon != -1 && *(data+5) != rcon  )
     return -1 ;
   return 1 ;
}



