#include <stdio.h>
#include "fconst.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


/**********************************************************
*   ***	ϥåؿ
*   USAGE:		hash( unsigned char *cp, int hmax)
*   SYNOPSIS:		unsigned char *cp  ϥåоݥ
*                       int  ksz           Υ
*                       int  ktype         Υ
*                       int  hmax          ϥå
*   DESCRIPTION:	
*	Ϳ줿ʸϥå󥰤롣
*
*   RETURN:             ʾ hmax̤
*
***********************************************************/

unsigned int hash(unsigned char *str,int ksz, int ktype, int hmax, int hsize)
{

  unsigned int	hashval = 0;
  unsigned char	tmp;
  int i ;

  if (( ktype & STR_TYPE) != 0 ) {
    if (hsize == -1) {
      for( i=0 ; i < ksz ; i++) {
        hashval <<= 3;
        tmp = *(unsigned char*)str & 0x7f;
        //hashval += ( (unsigned int)tmp - 0x1f );
        hashval += (unsigned int)tmp ;
        str++;
      }
    }
    else {
      for( i=0 ; i < ksz && i < hsize ; i++) {
        hashval <<= 3;
        tmp = *(unsigned char*)str & 0x7f;
        //hashval += ( (unsigned int)tmp - 0x1f );
        hashval += (unsigned int)tmp ;
        str++;
      }
    }
    return hashval % hmax ;
  }
  else {
    /****
    for( i=0 ; i < ksz ; i++) {
      //hashval *= 256 ;
      hashval = hashval << 8 ;
      hashval += *str ;
      str++;
    }
    *******/
    /* hashval = get4byte(str) ; */
    i = get4byte(str) ;
    if ( i < 0 )
       hashval = (-1) * i ;
    else
       hashval = i ;
    return hashval % hmax ;
  }
}


