/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

#ifndef  _FLIBCONST
#define  _FLIBCONST

/* ȥ֥å */
#define  CBSIZE     512
#define  PTCOUNT   (CBSIZE / 4)
/* ǡ֥å */
#define  BSIZE     512
     /* #define  BRSIZE    (BSIZE-8) */
#define  COLLISION 1024

/* ե饰ꥢ */
#define  IX_TYPE   0x0001
#define  DA_TYPE   0x0002
#define  DB_TYPE   0x0004
 /* ǥåץեΥΥ */
#define  STR_TYPE  0x0100
#define  BIN_TYPE  0x0200

/* Сֹ */
#define  VAR_NO    0x00010000
#define  REV_NO    0x00000001





typedef struct FileInfo {
  FILE            *fd     ;   /* եݥ       */
  unsigned char   *name   ;   /* ե̾         */
  unsigned int     flag   ;   /* եΥե饰   */
  unsigned int     rbsz   ;   /* 쥳ɥ֥å */
  int              hsize  ;   /* ϥåMAX      */
  int              hmax   ;   /* ϥå奨ȥ꡼ */
  int              curpt  ;   /* ȥǡݥ */
  int              rct    ;   /* 쥳ɥ       */
} CFile ;



typedef struct CharTbl {      /* type1 : tyoe2 */
  unsigned char *type1   ;  
  unsigned char *type2   ;  
} CharTable ;




typedef struct MorphData {
  int              flag  ;   /* ե饰ꥢ            */
  int              rno   ;   /* 쥳ֹ            */
  int              off   ;   /* եå              */
  int              leng  ;   /* ʸĹ                */
  unsigned char    lcon  ;   /* Ϣܾ              */
  unsigned char    rcon  ;   /* Ϣܾ              */
  unsigned char    pos   ;   /* ʻ                    */
  int              grmid ;   /* ʸˡɣ                */
  int              cid   ;   /* ǰɣġʿͽǡ  */
  struct MorphData *next ;   /* ¾Ǿ            */
} MorphInfo ;




#endif


