#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



int
main(int argc,  char **argv)
{
      int    flag ,ret ;
      int    jj, kk ;
      int    dct ;
      unsigned int stat;
      unsigned char   buff[16386] ; 
      unsigned char   buff2[16386] ;
      char  work[1024], work1[1024], work0[1024] ;
      char  putd[16] ;
      char   *cary[30], *cp ;
      CFile  *fpt , *dpt, *ypt, *cpt;
      int Rid ;
      char *wdenv ;
      char file[512] ;
      int len ;
      int dbflag = 0 ;

      InitEdrTbl() ;

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      strcpy( &file[len], "HDWD_IX" ) ;
      dpt = Create_IXT( file, 's', 20000 , 4, 64) ;
      strcpy( &file[len], "YOMI_IX" ) ;
      ypt = Create_IXT( file, 's', 30000 , 12, 64) ;
      strcpy( &file[len], "CP2W_IX" ) ;
      cpt = Create_IXT( file, 's', 10000 , -1, 64) ;
      strcpy( &file[len], "JWD" ) ;
      fpt = Create_IXT( file, 'b', 100000 , -1, 128) ;

      GRAM_DB_Open() ;
      //DB_FileOpen() ;

      dct = 0 ;

      while( gets(buff) != NULL ){
          if ( strncmp( buff, "Copyright", 9) == 0 ) {
            continue ;
	  }
          if ( strncmp( buff, "JWD", 3) != 0 ) {
            fprintf( stderr, "ERROR(CreateJWD):[%s]\n",buff ) ;
            continue ;
	  }
          dct++ ;
          if (( dct % 10000 ) == 0 ) {
            fprintf(stderr, "Put %d   \n",dct) ;
            //system("date") ;
          }
          //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
          len = CreateRec( dbflag, buff, buff2, 16386 ) ;
          if ( len == 0 ) {
            fprintf( stderr, ":[%s]\n",buff ) ; 
            continue ;
          }
          else if ( len < 0 ) {
            fprintf(stderr, "ERROR(CreateJWD):[%s]\n",buff ) ;
            continue ;
          }
          Rid = *(int *)buff2 ;
          ret = Put_IXT(fpt, buff2, 4, buff2, len) ;
          ret = StartPts(buff2,len,cary) ;
          /*** ɽǥå ***/
          if ( cary[6] != NULL && strcmp( cary[6], "\"\"") != 0 ) { 
             ret = GetFirstWd( cary[6] , work1, 1024) ;
             ret = EDR_StrStrip(work, work1) ;
             ret = Conv2Big(work0, work) ;
             if ( ret < 0 ) {
               printf("ERROR:HDWD:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
             }
             put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
             putd[4] = *cary[1] ;        /* Ϣ */
             putd[5] = *cary[2] ;        /* Ϣ */
             putd[6] = *cary[3] ;        /* ʻ   */
             putd[7] = 0xff ;                 
             ret = Add_IXT_DATA2( dpt, work0, strlen( work0 ), putd, 8) ;
	  }
          /*** ɤߥǥå(ɽ) ***/
          if ( cary[7] != NULL && strcmp( cary[7], "\"\"") != 0 ) { 
             ret = EDR_StrStrip(work, cary[7] ) ;
             cp = skip_ptr( '/', work )  ;
             ret = copy_word( work1, 1024 , work, cp ) ;
             ret = Conv2Big(work, work1) ;
             if ( ret < 0 ) {
               printf("ERROR:YOMI:Conv2Big:IN>[%s](%d)\n",buff,strlen(buff)) ;
             }
             put4byte( Rid, &putd[0] ) ; /* 쥳ֹ */
             putd[4] = *cary[1] ;        /* Ϣ */
             putd[5] = *cary[2] ;        /* Ϣ */
             putd[6] = *cary[3] ;        /* ʻ   */
             putd[7] = 0xff ;                 
             ret = Add_IXT_DATA2( ypt, work, strlen( work ), putd, 8) ;
	  }
          /*** ǰɣĥǥå ***/
          if ( cary[5] != NULL && strcmp( cary[5], "\"\"") != 0 ) { 
             ret = Add_IXT_DATA2( cpt, cary[5], strlen( cary[5] ), (char *)&Rid, 4) ;
	  }
          continue ;
      }

      GRAM_DB_Close() ;

      Close_IXT( dpt ) ;
      Close_IXT( ypt ) ;
      Close_IXT( fpt ) ;
      Close_IXT( cpt ) ;
      return 0 ;
}




