#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int   vflag = 2 ,ret1, ret2 ;
      int   jj, inct, nonct, sahen, sss ;
      char  work[1024], work1[1024] ;
      CFile *fpt1 , *dpt1;
      CFile *fpt2 , *dpt2;
      char  *wdenv ;
      char  file[512] ;
      MorphInfo  morph[4096] ;

      if ( argc > 1 ) {
        if ( strcmp( *(argv+1), "-EDR" ) == 0 ) 
          vflag = 0 ;
        if ( strcmp( *(argv+1), "-FV" ) == 0 ) 
          vflag = 1 ;
        if ( strcmp( *(argv+1), "-V" ) == 0 ) 
          vflag = 2 ;
      }


      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "HDWD_IX" ) ;
      dpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "THDWD_IX" ) ;
      dpt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "TJWD" ) ;
      fpt2 = Open_IXT( file, 'b' ) ;

      DB_FileOpen() ;
   
      inct = nonct = sahen = 0 ;
      while( gets( work ) != NULL ){
          if ( work[0] == '\0') continue ;
          sss = 0 ;
          inct++ ; 
          printf("IN>[%s](%d)\n",work,strlen(work)) ;
          ret1 = Conv2Big(work1, work) ;
          /* 쥳ֹΤߤ */
          ret1 = GetRecIDFromHdwd(0, dpt1, work1, &morph[0], 4096 ) ;
          if ( ret1 != 0 ) {
            printf("----------------------------------------ܸ()--------------\n") ;
            /* ѥå */
            for( jj= 0 ; jj < ret1 ; jj++) {
              if ( ChkJN1JVE(fpt1,morph[jj].rno) == 1 ) {
                sahen++ ;
                sss = 1 ;
                break ;
              }
            }  

            for( jj= 0 ; jj < ret1 ; jj++) {
              if ( vflag == 0 )
                PrnRecFromRID(stdout, fpt1,morph[jj].rno) ;  /* ţģҼɽ */
              else if ( vflag == 1 )
                PrnFVRecFromRID(stdout, fpt1,morph[jj].rno) ;/* FIELDVALUEɽ */
              else
                PrnVRecFromRID(stdout, fpt1,morph[jj].rno) ; /* VALUEɽ */
              printf("\n") ;
	    }
          }
          ret2 = GetRecIDFromHdwd(0, dpt2, work1, &morph[0], 4096 ) ;
          if ( ret2 != 0 ) {
            printf("----------------------------------------Ѹ()--------------\n") ;
            if ( sss == 0 ) {
              for( jj= 0 ; jj < ret2 ; jj++) {
                if ( ChkJN1JVE(fpt2,morph[jj].rno) == 1 ) {
                  sahen++ ;
                  sss = 1 ;
                  break ;
                }
              }
            }  

            for( jj= 0 ; jj < ret2 ; jj++) {
              if ( vflag == 0 )
                PrnRecFromRIDT(stdout, fpt2,morph[jj].rno) ;  /* ţģҼɽ */
              else if ( vflag == 1 )
                PrnFVRecFromRIDT(stdout, fpt2,morph[jj].rno) ;/* FIELDVALUEɽ */
              else
                PrnVRecFromRIDT(stdout, fpt2,morph[jj].rno) ; /* VALUEɽ */
              printf("\n") ;
	    }
          }
          /**********/
          if ( ret1 == 0 && ret2 == 0 )  {
            printf("NON:쥳[\t%s\t]¸ߤޤ\n",work1) ;
            nonct++ ;
          }
          else {
            if ( sss == 0 )
              printf("SAH_0:쥳[\t%s\t]ϥѤʻ줬¸ߤޤ\n",work1) ;
            else
              printf("SAHEN:쥳[\t%s\t]ϥѤ¸ߤޤ\n",work1) ;
          }
          /**************/
      }
      DB_FileClose() ;
      if ( dpt1 != NULL ) Close_IXT( dpt1 ) ;
      if ( dpt2 != NULL ) Close_IXT( dpt2 ) ;
      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;
      printf(" IN=%d  non=%d sahen=%d\n",inct,nonct,sahen) ;
}




int ChkJN1JVE( CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;
    unsigned char *cary[64] ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;

   ret = StartPts( data, ret, cary) ;
   //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
   //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
   //*
   //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
   //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

   //printf("START PrRid2EDRJWD[%s]\n",cary[6]) ;
   //debug2( rbuff, rsz ) ;

   if ( strcmp( "JN1;JVE", J_POS[*cary[3]].type1) == 0)
     return 1 ;

   return -1 ;
}

