#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



void
main(int argc,  char **argv)
{
      int    ret ;
      int    adct, ddct, udct ;
      unsigned int stat;
      char   buff[16386], *cp ; 
      CFile  *fpt , *dpt ;
      char *wdenv ;
      char file[512] ;
      int len ;
      int dbflag = 0 ;

      InitEdrTbl() ;

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        len = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[len++] = '/' ;
      }
      else {
        len = 0 ;
      }
      /* 쥳ֹ椫饰롼ףɣĤ򸡺 */
      strcpy( &file[len], "R2G_DB" ) ;
      fpt = Open_IXT( file, 'b' ) ;

      /* 롼ףɣĤ쥳ֹΥꥹȤ򸡺 */
      strcpy( &file[len], "G2R_IX" ) ;
      dpt = Open_IXT( file, 'b') ;

      DB_FileOpen() ;

      adct = udct = ddct = 0 ;

      while( gets(buff) != NULL ){
          cp = skip_non_sp( buff) ;
          if ( cp == NULL || *cp == '#' ) {
            continue ;
	  }
          if ( strncmp( buff, "MOV:\tGRP", 8) == 0 ) {
            ret = Update_GRP_DB( fpt, dpt,&buff[5] ) ;
            if ( ret >= 0 )
              udct++ ;
            continue ;
	  }
          if ( strncmp( buff, "DEL:\tGRP", 8) == 0 ) {
            ret = Delete_GRP_DB( fpt, dpt, &buff[5] ) ;
            if ( ret >= 0 )
              ddct++ ;
            continue ;
	  }
          if ( strncmp( buff, "ADD:\tGRP", 8) == 0 ) {
            ret = Add_GRP_DB( fpt, dpt, &buff[5] ) ;
            if ( ret >= 0 )
              adct++ ;
            continue ;
	  }
          fprintf(stderr, "ERROR:ϥǡ顼[%s]\n",buff) ;
      }
      fprintf( stderr," UPD: %d   DEL: %d   ADD: %d\n",udct,ddct,adct) ;      
      Close_IXT( fpt ) ;
      Close_IXT( dpt ) ;
      return ;
}




