/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

/****************************************************************
    ţģҷγǰηϤ˴ؤؿ
****************************************************************/




/****************************************************************
*   Ǽ쥳ɺ
*   USAGE:		CreateCpcRec( char *indata, char *outdata, int size, char **ptr)
*   SYNOPSIS:		char  *indata  (IN)   ǰηϼʣţģҼ
*                       char  *outdata (OUT)  쥳ɳǼ
*                       int   size            쥳ɳǼΥ
*                       char  **ptr    (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	ţģҷΥǡ顢ģ¤˳Ǽ쥳ɤ롣
*       ʲǼ쥳ɤΥեɹǤ롣
*       ƥեɤΥɥ쥹裴˥åȤ롣
*       裴ϥեɤοʬǤɬ
*
*        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
*        |  (4)   | (n)          | (n)          | (n)        |
*
*
*   RETURN:		record size
*                       ۾郎äϡ-1֤롣
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int  CreateCpcRec( char *str, char *out, int size)
{
  char buff2[16386] ;
  char dict[8], rnum[12] ;
  int  Rid = -1, Cid ;
  char  *bptr[64] ;
  int  tb, ret, len ,hdlen;
  unsigned char Lcon, Rcon, JPoS ;
  char *st = out ;

  tb = split1( '\t', str, bptr ) ;
  len = strlen(bptr[1]) + strlen(bptr[2]) + strlen(bptr[3]) + 3+ 4 ;
  if ( size <= len ) {
    return ( -1 ) ;
  }
  Rid = GetCode2Wid( bptr[0], dict, rnum) ;
  /*
  *if ( dict[0] == '\0' && rnum[0] == '\0' ) {
  *  return ( -1 ) ;
  *}
  */

  //printf("dict=[%s],rnum=[%s],  Rid=[%d]\n",dict,rnum,Rid);
  put4byte( Rid, out ) ;
  out += 4 ;
  strcpy( out, bptr[1] ) ; out += strlen(bptr[1]) + 1 ;
  strcpy( out, bptr[2] ) ; out += strlen(bptr[2]) + 1 ;
  strcpy( out, bptr[3] ) ; out += strlen(bptr[3]) + 1 ;
  return ( len ) ;
}





/****************************************************************
*   Ǽ쥳 եɥݥ
*   USAGE:		StartPtsCPC( char *rec, int len, char **cary)
*   SYNOPSIS:		char  *rec    (IN)   ǰηϼǼ쥳
*                       int   len     (IN)   쥳ɤΥ
*                       char  **cary  (OUT)  ƥեɤγǼݥ
*
*   DESCRIPTION:	
*	γƥեɤƬݥ󥿤ᡢ裳
*       ˥åȤ롣
*       ꥿ͤϤǿ
*
*        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
*        |  (4)   | (n)          | (n)          | (n)        |
*
*   RETURN:		եɿ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int StartPtsCPC(char *rec, int len, char **cary) 
{
  int   ii ;

  cary[0] = rec ;     /* Rec-ID */
  cary[1] = rec+4 ;   /* ̳ǰID */
  rec = rec + 4 + strlen(cary[1]) +1;
  cary[2] = rec ;     /* ̳ǰID */
  rec = rec + strlen(cary[2]) +1;
  cary[3] = rec ;     /*    */
  ii = 4 ;
  while(1) {
    rec = skip_ptr( ';', rec ) ;
    if (rec == NULL) {
      break ;
    }
    rec = skip_non_sp( rec +1 ) ;
    if (rec == NULL) {
      break ;
    }
    cary[ii++] = rec ;     /* ݻii */
  }
  return ii ;
}





