/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"



/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ
**************************************************************/
int  CurRecIDs[32768] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurRecCt = 0;       /*** ȥ쥳ɿ             ***/
int  BakRecIDs[32768] ;  /*** Υȥ쥳ֹǼꥢ ***/
int  BakRecCt = 0;       /*** Υȥ쥳ɿ             ***/

int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
void SetAccessDict( char *cp ) ;
void SetPrintMode( char *cp ) ;
void print_CurRecord( CFile *bjwd, CFile *tjwd, char *recid, char *file ) ;
void print_CurRecords( CFile *bjwd, CFile *tjwd, char *file ) ;
int  Select_by_cat( CFile *bjwd, CFile *tjwd, char *cat ) ;
int  Select_by_lr( CFile *bjwd, CFile *tjwd, char *cat ) ;
int  Access_by_date( CFile *log, char *date ) ;


void
main(int argc,  char **argv)
{
      int   vflag = 2 ,ret1, ret2 ;
      int   ii, jj , com;
      char  work[1024], work1[1024], work2[1024] ;
      CFile *cpt1, *fpt1 , *ypt1, *hpt1 ;
      CFile *cpt2, *fpt2 , *ypt2, *hpt2 ;
      CFile *lpt1, *lpt2  ;
      char  *wdenv ;
      char  file[512] ;
      MorphInfo  morph[4096] ;
      char  *ary[64] ;

      /*
         ưĶ
      */

      InitEnv() ;                /* ɽ⡼ɤʤɴĶ */
      DB_FileOpen() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */

      wdenv = (char *)getenv( "WORD_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "CP2W_IX" ) ;
      cpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "HDWD_IX" ) ;
      hpt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "YOMI_IX" ) ;
      ypt1 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "JWD" ) ;
      fpt1 = Open_IXT( file, 'b' ) ;
      strcpy( &file[jj], "WD_LOG" ) ;
      lpt1 = Open_IXT( file, 'b' ) ;

      wdenv = (char *)getenv( "TECH_DB" ) ;
      if ( wdenv != NULL ) {
        jj = strlen(wdenv) ;
        strcpy(file,wdenv) ;
        file[jj++] = '/' ;
      }
      else {
        jj = 0 ;
      }
      strcpy( &file[jj], "TCP2W_IX" ) ;
      cpt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "THDWD_IX" ) ;
      hpt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "TYOMI_IX" ) ;
      ypt2 = Open_IXT( file, 's') ;
      strcpy( &file[jj], "TJWD" ) ;
      fpt2 = Open_IXT( file, 'b' ) ;
      lpt2 = NULL ;

      if ( argc > 1 )  {
        ret1 = Conv2Big(work1, *(argv+1)) ;
        ret1 = BackUpCurentRec() ;
        CurRecCt = 0 ;
        ret1 = AccessEDRIDX( hpt1, work1 ) ;
        ret2 = AccessEDRIDX( hpt2, work1 ) ;
        if ( argc > 2 ) {
           ret1 = BackUpCurentRec() ;
           CurRecCt = 0 ;
           ret1 = AccessEDRIDX( cpt1, *(argv+2) ) ;
           ret1 = AccessEDRIDX( cpt2, *(argv+2) ) ;
           ret2 = IntersectEDRIDX() ;
	 }
         ENV_FLAGS &= ~( OUT_V | OUT_FV ); 
         ENV_FLAGS |= OUT_EDR ;
         print_CurRecords( fpt1, fpt2, ary[1] ) ;

         DB_FileClose() ;

         if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
         if ( ypt1 != NULL ) Close_IXT( ypt1 ) ;
         if ( hpt1 != NULL ) Close_IXT( hpt1 ) ;
         if ( cpt1 != NULL ) Close_IXT( cpt1 ) ;
         if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;
         if ( ypt2 != NULL ) Close_IXT( ypt2 ) ;
         if ( hpt2 != NULL ) Close_IXT( hpt2 ) ;
         if ( cpt2 != NULL ) Close_IXT( cpt2 ) ;
         return ;
      }

      while( 1 ) {
          if ( gets( work ) == NULL )
            break ;

          if ( strncmp( work, "###### IN>", 10) != 0 )
            continue ;

          gets( work1 ) ;
          printf( "%s\n", work ) ;
          printf( "%s\n", work1 ) ;

          ret1 = split1( '\t', work, ary) ;

          ret1 = Conv2Big(work1, ary[4]) ;
          CurRecCt = 0 ;
          ret1 = AccessEDRIDX( hpt1, work1 ) ;
          ret2 = AccessEDRIDX( hpt2, work1 ) ;
          print_CurRecords( fpt1, fpt2, NULL ) ;
       }

      DB_FileClose() ;

      if ( fpt1 != NULL ) Close_IXT( fpt1 ) ;
      if ( ypt1 != NULL ) Close_IXT( ypt1 ) ;
      if ( hpt1 != NULL ) Close_IXT( hpt1 ) ;
      if ( cpt1 != NULL ) Close_IXT( cpt1 ) ;
      if ( fpt2 != NULL ) Close_IXT( fpt2 ) ;
      if ( ypt2 != NULL ) Close_IXT( ypt2 ) ;
      if ( hpt2 != NULL ) Close_IXT( hpt2 ) ;
      if ( cpt2 != NULL ) Close_IXT( cpt2 ) ;
}



int BackUpCurentRec()
{
  int ii ;

  for( ii = 0 ; ii < CurRecCt ; ii++ ) 
    BakRecIDs[ii] = CurRecIDs[ii] ; 
  BakRecCt = CurRecCt ;
  return BakRecCt ;
}


int RecoverCurentRec()
{
  int ii ;
  for( ii = 0 ; ii < BakRecCt ; ii++ )
    CurRecIDs[ii] = BakRecIDs[ii] ;
  CurRecCt = BakRecCt ;
  return BakRecCt ;
}


int AccessEDRIDX( CFile *hpt, char *key ) 
{
  int ret ;
  int ii ;
  MorphInfo  morph[4096] ;

  if ( hpt == NULL )
    return 0 ;
  ret = GetRecIDFromHdwd(0, hpt, key, &morph[0], 4096) ;
  if ( ret == 0 )
    return ret ;
  for( ii = CurRecCt ; ii < ret ; ii++ ) {
    CurRecIDs[ii] = morph[ii].rno ;
  }
  CurRecCt = ii ;
  return ret ;
}


int IntersectEDRIDX()
{
  int ii, jj, kk ;

  kk = 0 ;
  for( ii = 0 ; ii < CurRecCt ; ii++ ) {
    for ( jj = 0 ; jj < BakRecCt ; jj++ ) {
      if ( CurRecIDs[ii] == BakRecIDs[jj] ) {
        CurRecIDs[kk++] = CurRecIDs[ii] ;
        break ;
      }
    }
  }
  CurRecCt = kk ;
}



/* ȥ쥳ɤ򥢥ʻΤΤ򤹤 */
int  Select_by_cat( CFile *bjwd, CFile *tjwd, char *cat )
{
  int id, ii, kk ;


  id = GetJPoSID( cat ) ;

  if ( id == 255 ) {
    fprintf(stderr,"ERROR(Select_by_cat):Unknown cat[%s]\n",cat) ;
    RecoverCurentRec() ;
    return 0 ;    
  }

  kk = 0 ;  
  for ( ii = 0 ; ii < BakRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( ChkRecByCat( bjwd, BakRecIDs[ii], id)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
    if ( tjwd != NULL ) {
      if ( ChkRecByCat( tjwd, BakRecIDs[ii], id)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
  }
  CurRecCt = kk ;
  return 1;
}







/* ȥ쥳ɤ򥢥ꤵ줿Ϣ°ΤΤ򤹤 */
int Select_by_lr( CFile *bjwd, CFile *tjwd, char *lrcon )
{
  int id, ii, kk, lcon, rcon ;
  char work[32], *cp ;

  cp = skip_ptr( ',', lrcon ) ;
  if (cp == NULL) {
    fprintf(stderr,"ERROR(Select_by_lr):Unknown L,R[%s]\n",lrcon) ;
    RecoverCurentRec() ;
    return 0 ;    
  }
  copy_word( work, 32, lrcon, cp ) ;
  if ( work[0] == '\0' || work[0] == '*' ) 
    lcon = -1 ;
  else 
    lcon = GetLconID( work ) ;
  cp = skip_non_sp( cp +1 ) ;
  if ( cp == NULL || *cp == '*' ) 
    rcon = -1 ;
  else
    rcon = GetRconID( cp ) ;

  //printf("Select_by_lr start lcon =%d rcon=%d\n",lcon,rcon) ;
  if ( lcon == 255 || rcon == 255 ) {
    fprintf(stderr,"ERROR(Select_by_lr):Unknown L,R[%s](%d,%d)\n",lrcon,lcon,rcon) ;
    RecoverCurentRec() ;
    return 0 ;    
  }

  kk = 0 ;  
  for ( ii = 0 ; ii < BakRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( ChkRecByLRcon( bjwd, BakRecIDs[ii], lcon, rcon)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
    if ( tjwd != NULL ) {
      if ( ChkRecByLRcon( tjwd, BakRecIDs[ii], lcon, rcon)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
  }
  CurRecCt = kk ;
  return 1;
}



int Access_by_date( CFile *log, char *date )
{
/* DB򥢥ꤵ줿֤˹줿Τ򤹤 */
  int  ret ,ret1;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[4096], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;
  //printf("ret=%d\n",ret) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  ret = split1( '-', date, ary) ;

  if ( ary[0] == '\0' ) { /*  1997.1.1 */
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else
    tob = PStrDate2PI( ary[1] ) ;

  //printf("from[%x], tob=[%x]\n",fromb,tob) ;
  ret = ret1 = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 4096) ;
    if ( len <= 0 )
      continue ;
    len = CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      ret1++ ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret1 >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}








/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return 0 ;
  }
  ary[0] = cp ;
  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룱 */
      case  'h' :  ret = 1 ; break ;
      case  'R' :          /* reading    ɤߤˤ룱 */
      case  'r' :  ret = 2 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룱 */
      case  'c' :  ret = 3 ; break ;
      case  'D' :          /* from-to    ˤ룱 */
      case  'd' :  ret = 4 ; break ;
      defaule   :  return 0 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'S' || *cp == 's' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룲 */
      case  'h' :  ret = 11 ; break ;
      case  'R' :          /* reading    ɤߤˤ룲 */
      case  'r' :  ret = 12 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룲 */
      case  'c' :  ret = 13 ; break ;
      case  'D' :          /* from-to    ˤ룲 */
      case  'd' :  ret = 14 ; break ;
      case  'P' :          /* POS        ʻˤ룲 */
      case  'p' :  ret = 15 ; break ;
      case  'L' :          /* Lcon,Rcon  Ϣܾˤ룲 */
      case  'l' :  cp++ ;
                   if ( *cp != 'R' && *cp != 'r')
                     return 0 ;
                   ret = 16 ; break ;
      default   :  return 0 ;
    }
    cp++ ;
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    if ( *cp == '\0' || *cp <= ' ' )  {
      ary[1] = skip_non_sp( cp ) ;
      return 21 ;          /* ȥ쥳ɤξɽؼ */
    }
    if ( *cp == 'M' || *cp == 'm' ) {
      cp++ ;
      SetPrintMode(cp) ;   /* ץȥ⡼ɤ */
      return 0 ;
    }
  }
  if (*cp == 'I' || *cp == 'i' ) {
    ary[1] = skip_non_sp( cp + 1 ) ;
    if ( ary[1] == NULL ) {
      fprintf(stderr,"ERROR(InputCom): 쥳ֹλ꤬ޤ\n") ;
      return 0 ;
    }  
    cp = skip_a_word(ary[1]) ;
    ary[2] = skip_non_sp( cp ) ;
    return 20 ;            /* ꤵ줿쥳ɣɣĤξɽ */
  }
  if (*cp == 'A' || *cp == 'a' ) {
    cp++ ;
    SetAccessDict(cp) ;
    return 0 ;
  }
  if ( *cp == 'B' || *cp == 'b' ) {
    cp++ ;
    if ( *cp == '\0' || skip_non_sp( cp ) == NULL ) 
      RecoverCurentRec() ;
    return 0 ;
  }
  /* Default FH */
  ary[1] = skip_non_sp( cp ) ;
  return 1 ;
}






/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS ****************(Current Record = %d)\n",CurRecCt) ;
  fprintf( stderr,"FH  headword   ɽˤ룱\n") ;
  fprintf( stderr,"FR  reading    ɤߤˤ룱\n") ;
  fprintf( stderr,"FC  ConceptID  ǰ̻Ҥˤ룱\n") ;
  fprintf( stderr,"FD  from-to    ˤ󸡺\n") ;

  fprintf( stderr,"SH  headword   ɽˤ룲\n") ;
  fprintf( stderr,"SR  reading    ɤߤˤ룲\n") ;
  fprintf( stderr,"SC  ConceptID  ǰ̻Ҥˤ룲\n") ;

  fprintf( stderr,"SP  POS        ʻˤ룲\n") ;
  fprintf( stderr,"SLR left,right Ϣܾˤ룲\n") ;

  fprintf( stderr,"I   RID [file] 쥳IDˤɽؼ\n") ;
  fprintf( stderr,"P   [file]     ȥ쥳ɤɽ\n") ;
  fprintf( stderr,"PM  {V}/FV/EDR ץȥ⡼ɤ\n") ;
  fprintf( stderr,"A   {BT}/B/T   \n") ;
  fprintf( stderr,"B              θ̤᤹\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr,"  from,to yyyymmdd ϡ\n") ;
  fprintf( stderr,"\n") ;
}




int InitEnv()
{
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= ACCE_B | ACCE_T ;   /* ܸѸξ򥢥 */
  ENV_FLAGS |= OUT_V ;             /* ɽ⡼:VALUEΤߤɽ⡼ɤ */
  return 1 ;
}



/* ɽ⡼ɤ */
void SetPrintMode( char *cp )
{
  cp = skip_non_sp( cp ) ;

  if ( ( *cp == 'V' || *cp == 'v') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_FV | OUT_EDR ); 
    ENV_FLAGS |= OUT_V ;
    return ;
  }
  if ( ( strncmp(cp,"FV",2) == 0 ||
         strncmp(cp,"fv",2) == 0 ) && *(cp+2) <= ' ') {
    ENV_FLAGS &= ~( OUT_V | OUT_EDR ); 
    ENV_FLAGS |= OUT_FV ;
    return ;
  }
  if ( ( strncmp(cp,"EDR",3) == 0 ||
         strncmp(cp,"edr",3) == 0 ) && *(cp+3) <= ' ') {
    ENV_FLAGS &= ~( OUT_V | OUT_FV ); 
    ENV_FLAGS |= OUT_EDR ;
    return ;
  }
  fprintf( stderr,"ERROR(SetPrintMode):Unknown[%s]\n",cp) ;
}



/* 뼭ꤹ */
void SetAccessDict( char *cp )
{
  if ( ( *cp == 'B' || *cp == 'b') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_T ; 
    ENV_FLAGS |= ACCE_B ;
    return ;
  }
  if ( ( *cp == 'T' || *cp == 't') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_B ; 
    ENV_FLAGS |= ACCE_T ;
    return ;
  }
  if ( ( strncmp(cp,"BT",3) == 0 ||
         strncmp(cp,"bt",3) == 0 ||
         strncmp(cp,"TB",3) == 0 ||
         strncmp(cp,"tb",3) == 0   ) && *(cp+3) <= ' ') {
    ENV_FLAGS |= ACCE_B | ACCE_T ;
    return ;
  }
  fprintf( stderr,"ERROR(SetAccessDict):Unknown[%s]\n",cp) ;
}




void print_CurRecord( CFile *bjwd, CFile *tjwd, char *recid, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  char dict[32], ids[32] ;
  int  ret , id ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_Record):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }
  if ( *recid == 'J' || *recid == 'T' )
    id = GetCode2Wid( recid, dict, ids) ;
  else 
    id = atoi( recid ) ;

  if ( bjwd != NULL ) {
    if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
      PrnRecFromRID(fp, bjwd,id) ;  /* ţģҼɽ */
    if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
      PrnFVRecFromRID(fp, bjwd,id) ;/* FIELDVALUEɽ */
    if ( (ENV_FLAGS & OUT_V ) != 0 )  
      PrnVRecFromRID(fp, bjwd,id) ; /* VALUEɽ */
  }
  if ( tjwd != NULL ) {
    if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
      PrnRecFromRIDT(fp, tjwd,id) ;  /* ţģҼɽ */
    if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
      PrnFVRecFromRIDT(fp, tjwd,id) ;/* FIELDVALUEɽ */
    if ( (ENV_FLAGS & OUT_V ) != 0 )  
      PrnVRecFromRIDT(fp, tjwd,id) ; /* VALUEɽ */
  }
  fprintf(fp,"\n") ;
  if ( flag != 0 )
    fclose( fp ) ;
}



void print_CurRecords( CFile *bjwd, CFile *tjwd, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  int  ret , ii ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_CurRecord):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }

  for ( ii = 0 ; ii < CurRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
        PrnRecFromRID( fp, bjwd,CurRecIDs[ii]) ;  /* ţģҼɽ */
      if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
        PrnFVRecFromRID( fp, bjwd,CurRecIDs[ii]) ;/* FIELDVALUEɽ */
      if ( (ENV_FLAGS & OUT_V ) != 0 ) 
        PrnVRecFromRID( fp, bjwd,CurRecIDs[ii]) ; /* VALUEɽ */
    }
    if ( tjwd != NULL ) {
      if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
        PrnRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ;  /* ţģҼɽ */
      if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
        PrnFVRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ;/* FIELDVALUEɽ */
      if ( (ENV_FLAGS & OUT_V ) != 0 ) 
        PrnVRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ; /* VALUEɽ */
    }
  }

  if ( flag != 0 )
    fclose( fp ) ;


}







